! cvs_file_1d.f90 --
!     Include file for csv_file.f90:
!     contains the body of the one-dimensional version of the
!     writing routines.
!
!     $Id: csv_file_1d.f90,v 1.2 2006/03/26 19:03:53 arjenmarkus Exp $
!
    integer, intent(in)                 :: lun ! LU-number of the CSV-file
    logical, intent(in), optional       :: advance ! Advance (.true.) or not, so that more items can be written to the same record

    logical                             :: adv
    integer                             :: i

    adv = .true.
    if ( present(advance) ) adv = advance

    do i = 1,size(array)-1
        call csv_write( lun, array(i), .false. )
    enddo
    call csv_write( lun, array(size(array)), adv )
!
! end of body

program gwgen

    use csv_file,      only : csv_write
    use parametersmod, only : sp, tfreeze
    use weathergenmod, only : metvars_in, metvars_out, weathergen, init_weathergen, &
                              rmsmooth
    use randomdistmod, only : ran_seed
    use geohashmod,    only: geohash

    implicit none

    character(200) :: infile
    character(200) :: output
    character(200) :: dailyfile

    integer, parameter :: n = 1
    integer, parameter :: n_curr = n + 1
    integer, parameter :: n_tot = n * 2 + 1
    character(12), parameter :: NOSTATION = '__NOSTATION'

    integer :: i, d, rmin, rd, lmin, ld, curr_start, curr_end, end_counter = n
    integer :: year(n_tot) = 0     ! month of previous, current, next and the month after the next month
    integer :: month(n_tot) = 0    ! year of previous, current, next and the month after the next month

    character(12) :: stationid(n_tot) = NOSTATION  ! previous, current and next station

    real(sp) :: lon(n_tot) = 0  ! longitude of the station of previous, current, next and the month after the next month
    real(sp) :: lat(n_tot) = 0  ! latitude of the station of previous, current, next and the month after the next month

    real(sp) :: mprec(n_tot) = 0    ! precipitation amount of current month
    integer  :: mwet(n_tot) = 0      ! number of wet days of current month
    real(sp) :: mtmin(n_tot) = 0  ! min temperture of previous, current, next and the month after the next month
    real(sp) :: mtmax(n_tot) = 0  ! min temperture of previous, current, next and the month after the next month
    real(sp) :: mcloud(n_tot) = 0 ! cloudiness of previous, current, next and the month after the next month
    real(sp) :: mwind(n_tot) = 0 ! wind speed of previous, current, next and the month after the next month

    real(sp), target :: tmin_sm(n_tot * 31) = 0   ! smoothed daily values of min temperature
    real(sp), target :: tmax_sm(n_tot * 31) = 0   ! smoothed daily values of max temperature
    real(sp), target :: cloud_sm(n_tot * 31) = 0  ! smoothed daily values of cloudiness
    real(sp), target :: wind_sm(n_tot * 31) = 0   ! smoothed daily values of wind speed

    real(sp) :: bcond_tmin(2) = 0      ! boundary conditions of min temp for smoothing
    real(sp) :: bcond_tmax(2) = 0      ! boundary conditions of max temp for smoothing
    real(sp) :: bcond_cloud(2) = 0     ! boundary conditions of cloud for smoothing
    real(sp) :: bcond_wind(2) = 0      ! boundary conditions of wind speed for smoothing

    integer :: i_consecutives(n_tot - 1)

    ! pointers to the tmin, tmax, cloud and wind speed values of the current month
    real(sp), pointer :: mtmin_curr(:), mtmax_curr(:), mcloud_curr(:), mwind_curr(:)

    integer  :: mwetd_sim, wet_day
    real(sp) :: mprec_sim

    integer :: pdaydiff

    real(sp) :: precdiff

    real(sp) :: tmindiff, tmin_acc

    type(metvars_in)  :: met_in
    type(metvars_out) :: met_out
    type(metvars_out) :: met_out_save

    integer :: ndm(n_tot) = 0

    real(sp) :: prec_t

    integer :: i_count, i_linecount = n_curr + 1

    type(metvars_out), dimension(31) :: month_met

    ! -----------------------------------------------------------------------------
    ! ------------------- Defaults for the namelist parameters --------------------
    ! -----------------------------------------------------------------------------
    integer :: seed = -30000 ! seed for the random number generator. Has no effect if use_geohash is .true.
    ! logical to determines whether the geohashmod module shall be used for
    ! defining the random seed. If .true., the first three columns must be
    ! stationid, longitude, latitude. Otherwise longitude and latitude should be
    ! skipped
    logical :: use_geohash = .true.
    logical :: ldebug = .false.  ! switch to output additional informations
    logical :: lreset = .true. ! switch to reset the residuals every month

    ! -----------------------------------------------------------------------------
    ! ------------------- END. Defaults for the namelist parameters ---------------
    ! -----------------------------------------------------------------------------

    namelist / main_ctl / seed, use_geohash, ldebug, lreset

    open(101,file='weathergen.nml',status='old')
    read(101, main_ctl)
    call init_weathergen(101)
    close(101)

    !initialize random state


    call getarg(1,infile)
    call getarg(2,output)

    open(10,file=infile,status='old')
    ! consume header
    read(10,*)

    ! read in the first n months and calculate the wet days


    if (use_geohash) then
        do i=n_curr,n_tot-1

            read(10,*)stationid(i),lon(i),lat(i),year(i), month(i),mtmin(i),mtmax(i), &
                   mcloud(i),mwind(i),mprec(i),mwet(i)
            ndm(i) = ndaymonth(year(i), month(i))

        end do
    else
        do i=n_curr,n_tot-1

            read(10,*)stationid(i),year(i), month(i),mtmin(i),mtmax(i), &
                       mcloud(i),mwind(i),mprec(i),mwet(i)
            ndm(i) = ndaymonth(year(i), month(i))

        end do
        call ran_seed(seed,met_in%rndst)
    endif

    ! open the output file
    dailyfile = trim(output)

    open(30,file=dailyfile,status='unknown')
    write(30,'(a)', advance='no') "id,year,month,day,tmin,tmax,mean_cloud,wind,prcp,wet_day"
    if (ldebug) then
        write(30,'(a)', advance='no') ",tmin_bias,tmin_mn,tmin_sd,wind_bias,wind_intercept_bias,"
        write(30,'(a)', advance='no') "wind_mn,wind_sd,resid_tmin,resid_tmax,resid_cloud,resid_wind,"
        write(30, '(a)') "unorm_tmin,unorm_tmax,unorm_cloud,unorm_wind"
    else
        write(30, '(a)') ''
    endif

    do  !read the input file until the end

        ! nullify pointers
        nullify(mtmin_curr)
        nullify(mtmax_curr)
        nullify(mcloud_curr)
        nullify(mwind_curr)

        i_linecount = i_linecount + 1

        !read in one month of summary weather station data from a text file
        if (use_geohash) then
            read(10,*,end=99)stationid(n_tot),lon(n_tot),lat(n_tot),year(n_tot),month(n_tot), &
                           mtmin(n_tot),mtmax(n_tot),mcloud(n_tot),mwind(n_tot),mprec(n_tot), &
                           mwet(n_tot)
            ndm(n_tot) = ndaymonth(year(n_tot),month(n_tot))
            if (stationid(n_curr) /= stationid(n)) then
                call ran_seed(geohash(lon(n_curr), lat(n)),met_in%rndst)
            end if
        else
            read(10,*,end=99)stationid(n_tot),lon(n_tot),lat(n_tot),year(n_tot),month(n_tot), &
                           mtmin(n_tot),mtmax(n_tot),mcloud(n_tot),mwind(n_tot),mprec(n_tot), &
                           mwet(n_tot)
            ndm(n_tot) = ndaymonth(year(n_tot),month(n_tot))
        endif

        goto 110

        ! ------ this part is skipped if we are not already at the end of the file -------------
99 continue
            end_counter = end_counter - 1
            stationid(n_tot) = NOSTATION
        ! ---------------------------------------------------------------------------------------
110 continue

        ! ------ check for invalid values
        if (mprec(n_tot) < 0.0 .and. mprec(n_tot) > -0.1) then
            mprec(n_tot) = 0.0
        elseif (mprec(n_tot) < -0.1) then
            write(0,*) "Invalid precipitation value", mprec(n_tot), "mm/d at line ", i_linecount
            stop 1
        endif
        if (mtmin(n_tot) + tfreeze < 0.0) then
            write(0,*) "Invalid minimum temperature value", mtmin(n_tot), "degC at line ", i_linecount
            stop 1
        elseif (mtmax(n_tot) + tfreeze < 0.0) then
            write(0,*) "Invalid maximum temperature value", mtmax(n_tot), "degC at line ", i_linecount
            stop 1
        elseif (mcloud(n_tot) < 0.0 .or. mcloud(n_tot) > 1.0) then
            write(0,*) "Invalid cloud fraction ", mcloud(n_tot), "at line ", i_linecount
            stop 1
        elseif (mwind(n_tot) < 0.0) then
            write(0,*) "Invalid wind speed ", mwind(n_tot), "m/s at line ", i_linecount
            stop 1
        endif

        i_consecutives(:) = are_consecutive_months(stationid,year,month)

        if (any(i_consecutives(n:1:-1) == 0)) then
            lmin = n_curr - minloc(i_consecutives(n:1:-1), 1) + 1
            ld = max(1, SUM(ndm(:lmin - 1)))
            bcond_tmin(1) = mtmin(lmin - 1)
            bcond_tmax(1) = mtmax(lmin - 1)
            bcond_cloud(1) = mcloud(lmin - 1)
            bcond_wind(1) = mwind(lmin - 1)
        else
            lmin = 1
            ld = 1
        end if

        if (any(i_consecutives(n+1:) == 0)) then
            rmin = n + minloc(i_consecutives(n+1:), 1)
            bcond_tmin(2) = mtmin(rmin)
            bcond_tmax(2) = mtmax(rmin)
            bcond_cloud(2) = mcloud(rmin)
            bcond_wind(2) = mwind(rmin)
        else
            rmin = n_tot
            bcond_tmin(2) = mtmin(n_tot)
            bcond_tmax(2) = mtmax(n_tot)
            bcond_cloud(2) = mcloud(n_tot)
            bcond_wind(2) = mwind(n_tot)
        end if
        rd = SUM(ndm(:rmin))

        call rmsmooth(mtmin(lmin:rmin), ndm(lmin:rmin), bcond_tmin, tmin_sm(ld:rd))
        call rmsmooth(mtmax(lmin:rmin), ndm(lmin:rmin), bcond_tmax, tmax_sm(ld:rd))
        call rmsmooth(mcloud(lmin:rmin), ndm(lmin:rmin), bcond_cloud, cloud_sm(ld:rd))
        call rmsmooth(mwind(lmin:rmin), ndm(lmin:rmin), bcond_wind, wind_sm(ld:rd))

        curr_start = sum(ndm(:n))
        curr_end = curr_start + ndm(n+1) - 1

        mtmin_curr => tmin_sm(curr_start:curr_end)
        mtmax_curr => tmax_sm(curr_start:curr_end)
        mcloud_curr => cloud_sm(curr_start:curr_end)
        mwind_curr => wind_sm(curr_start:curr_end)

        met_in%prec = mprec(n_curr)
        met_in%wetd = real(mwet(n_curr))
        met_in%wetf = real(mwet(n_curr)) / real(ndm(n_curr))

        !initialize weather residuals and other variables that carry over from one day to the next
        !these and the random state below should be reset once per station

        if (i_consecutives(n_curr - 1) == 0) then
            met_out%pday(1) = .false.
            met_out%pday(2) = .false.
            met_out%resid = 0.
            i_count = 1
        else if (lreset) then
            met_out%resid = 0.
            i_count = 1
        else
            i_count = 2
        end if
        prec_t = max(0.5,0.05 * mprec(n_curr))  !set quality threshold for preciptation amount

        ! save the current state of the residuals and pday
        met_out_save = met_out

        do

            mwetd_sim = 0
            mprec_sim = 0.
            tmin_acc = 0.0

            !start day loop

            do d = 1,ndm(n_curr)

                met_in%tmin  = mtmin_curr(d)
                met_in%tmax  = mtmax_curr(d)
                met_in%cldf  = real(mcloud_curr(d))
                met_in%wind  = real(mwind_curr(d))
                met_in%pday  = met_out_save%pday
                met_in%resid = met_out_save%resid

                call weathergen(met_in,met_out)

                met_in%rndst = met_out%rndst

                month_met(d) = met_out

                if (met_out%prec > 0.) then
                    mwetd_sim = mwetd_sim + 1
                    mprec_sim = mprec_sim + met_out%prec
                end if
                tmin_acc = tmin_acc + met_out%tmin

            end do

            !end of month
            ! NOTE: THIS HAS TO BE ENABLED IF NECESSARY
            tmindiff = 1.0  !abs(mtmin(n_curr) - tmin_acc / ndm(n_curr))

            ! Reset met_out_save after initialization
            if (i_count == 1) then
                if (i_consecutives(n_curr - 1) == 0) then
                    met_out_save = met_out
                else
                    met_out_save%resid = met_out%resid
                end if
            endif

            if (mprec(n_curr) <= 0.1 .and. tmindiff < 2.5) then

                pdaydiff = 0
                precdiff = 0.

                exit

            else if (i_count >= 2) then  !enforce at least two times over the month to get initial values ok

                pdaydiff = abs(mwet(n_curr) - mwetd_sim)
                precdiff = abs(mprec(n_curr) - mprec_sim)

                ! restrict simulated total monthly precip to +/-5% or 0.5 mm of observed value
                if (pdaydiff <= 1 .and. precdiff <= prec_t .and. tmindiff < 2.5) then
                    exit

                else if (i_count > 10000000) then
                    write (*,*) "No good solution found after 10000000 iterations at line", i_linecount
                    stop 1

                end if

            end if

            i_count = i_count + 1

        end do

        !write out final results for this station/year/month combo and

        do d = 1,ndm(n_curr)
            if (month_met(d)%prec > 0) then
                wet_day = 1
            else
                wet_day = 0
            end if
            call csv_write(30,stationid(n_curr),advance=.false.)
            call csv_write(30,year(n_curr),advance=.false.)
            call csv_write(30,month(n_curr),advance=.false.)
            call csv_write(30,d,advance=.false.)
            call csv_write(30,month_met(d)%tmin,advance=.false.)
            call csv_write(30,month_met(d)%tmax,advance=.false.)
            call csv_write(30,month_met(d)%cldf,advance=.false.)
            call csv_write(30,month_met(d)%wind,advance=.false.)
            call csv_write(30,month_met(d)%prec,advance=.false.)
            call csv_write(30,wet_day,advance=.not. ldebug)
            if (ldebug) then
                call csv_write(30,month_met(d)%tmin_bias,advance=.false.)
                call csv_write(30,month_met(d)%tmin_mn,advance=.false.)
                call csv_write(30,month_met(d)%tmin_sd,advance=.false.)
                call csv_write(30,month_met(d)%wind_bias,advance=.false.)
                call csv_write(30,month_met(d)%wind_intercept_bias,advance=.false.)
                call csv_write(30,month_met(d)%wind_mn,advance=.false.)
                call csv_write(30,month_met(d)%wind_sd,advance=.false.)
                call csv_write(30,month_met(d)%resid(1),advance=.false.)
                call csv_write(30,month_met(d)%resid(2),advance=.false.)
                call csv_write(30,month_met(d)%resid(3),advance=.false.)
                call csv_write(30,month_met(d)%resid(4),advance=.false.)
                call csv_write(30,month_met(d)%unorm(1),advance=.false.)
                call csv_write(30,month_met(d)%unorm(2),advance=.false.)
                call csv_write(30,month_met(d)%unorm(3),advance=.false.)
                call csv_write(30,month_met(d)%unorm(4),advance=.true.)
            end if
        end do

        ! set boundary conditions for next timestep
        ! left boundary condition: the end of the last month
        ! right boundary condition: we try to use the month after the next two months
        ! (see code above) but if that does not work, we use here the end of the
        ! month after the next month
        bcond_tmin(:) = (/ tmin_sm(ld), tmin_sm(rd) /)
        bcond_tmax(:) = (/ tmax_sm(ld), tmax_sm(rd) /)
        bcond_cloud(:) = (/ cloud_sm(ld), cloud_sm(rd) /)
        bcond_wind(:) = (/ wind_sm(ld), wind_sm(rd) /)

        stationid(1:n_tot-1) = stationid(2:n_tot)
        year(1:n_tot-1) = year(2:n_tot)
        month(1:n_tot-1) = month(2:n_tot)
        mprec(1:n_tot-1) = mprec(2:n_tot)
        mwet(1:n_tot-1) = mwet(2:n_tot)
        mtmin(1:n_tot-1) = mtmin(2:n_tot)
        mtmax(1:n_tot-1) = mtmax(2:n_tot)
        mcloud(1:n_tot-1) = mcloud(2:n_tot)
        mwind(1:n_tot-1) = mwind(2:n_tot)
        ndm(1:n_tot-1) = ndm(2:n_tot)
        lat(1:n_tot-1) = lat(2:n_tot)
        lon(1:n_tot-1) = lat(2:n_tot)

        !loop to next station/year/month
        if (end_counter == 0) then
            exit
        end if

    end do

    close(10)
    close(30)

    contains

    !-------------------------------------

    function are_consecutive_months(stationid, year, month) result(r)
        ! Check whether the given entries belong to consecutive months
        !
        ! This function checks whether the given `months` are consecutive. The
        ! return is a logical array with length ``size(stationid) - 1``.

        ! The first value is True if the second month is a consecutive month
        ! of the first month, the second value is True if the third month is
        ! a consecutive month of the second one, and so on. Months are only
        ! seen as consecutive if the `stationid` of the corresponding months
        ! are the same

        character(12), intent(in) :: stationid(:) ! the station ids of the entries
        integer, intent(in)       :: year(:) ! the years of the entries
        integer, intent(in)       :: month(:) ! the months of the entries
        integer                   :: i, r(size(stationid) - 1)

        do i=1,size(r)
            if (stationid(i) /= stationid(i + 1)) then
                r(i) = 0
            else
                if (month(i) == 12) then
                    r(i) = l2i(((year(i + 1) == year(i) + 1) .and. (month(i+1) == 1)))
                else
                    r(i) = l2i(((year(i + 1) == year(i)) .and. (month(i+1) == month(i) + 1)))
                end if
            end if
        end do

    end function are_consecutive_months

    !-------------------------------------

    integer function l2i(l)
        ! convenience function to convert a logical to an integer in [0, 1]

        logical :: l ! the logical to convert

        if (l) then
            l2i = 1
        else
            l2i = 0
        end if

    end function l2i

    !-------------------------------------

    integer function ndaymonth(year,month)
        ! get the number of days in a month given the year in calendar years AD and the month number

        integer, intent(in) :: year ! the year of the month
        integer, intent(in) :: month ! the month

        integer, parameter, dimension(12) :: std_year = [ 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 ]
        integer, parameter, dimension(12) :: leapyear = [ 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 ]

        if (mod(year,400) == 0) then

            ndaymonth = leapyear(month)

        else if (mod(year,100) == 0) then

            ndaymonth = std_year(month)

        else if (mod(year,4) == 0) then

            ndaymonth = leapyear(month)

        else

            ndaymonth = std_year(month)

        end if

    end function ndaymonth

!-------------------------------------

end program gwgen

module csv_file
    ! Small module to facilitate writing CSV-files
    !
    ! The module contains the following subroutines:
    !
    ! csv_next_record
    !     Advance to the next record
    ! csv_write_integer
    !     Write a single integer to the CSV-file
    ! csv_write_real
    !     Write a single real to the CSV-file
    ! csv_write_dble
    !     Write a single double-precision real to the CSV-file
    ! csv_write_char
    !     Write a single character string to the CSV-file
    ! csv_write_integer_1d
    !     Write a 1D array of integers to the CSV-file
    ! csv_write_real_1d
    !     Write a 1D array of reals to the CSV-file
    ! csv_write_dble_1d
    !     Write a 1D array of double-precision real to the CSV-file
    ! csv_write_char_1d
    !     Write a 1D array of character strings to the CSV-file
    ! csv_write_integer_2d
    !     Write a 2D array of integers to the CSV-file
    ! csv_write_real_2d
    !     Write a 2D array of reals to the CSV-file
    ! csv_write_dble_2d
    !     Write a 2D array of double-precision real to the CSV-file
    ! csv_write_char_2d
    !     Write a 2D array of character strings to the CSV-file
    !
    ! For convenience, the generic name "csv_write" can be used
    ! instead of the individual routines.
    !
    ! The file to write to must already be opened as a LU-number
    ! is passed.
    !
    ! Layout of the CSV-file:
    ! -----------------------
    ! - single items are written to the end of the current record
    ! - one-dimensional items are also written to the end of the current
    !   record
    ! - two-dimensional items are written to separate records, one for
    !   each row
    ! - except for the two-dimensional versions, all routines allow
    !   you to suppress advancing to the next record:
    !
    !   - for single items you must indicate whether to advance or not
    !   - for one-dimensional items, the argument is optional. Default
    !     is to advance.
    !
    ! Note on the format:
    ! -------------------
    ! CSV-files apparently come in different guises (Kernighan and Pike,
    ! The practice of Programming, Addison-Wesley, 1999). This module
    ! uses the following rules:
    !
    ! - items are always separated by a single comma (,)
    ! - string items are delimited by double quotes (")
    ! - embedded double quotes are treated by doubling the quote
    ! - trailing blanks are considered irrelevant

    ! $Id: csv_file.f90,v 1.2 2006/03/26 19:03:53 arjenmarkus Exp $
    implicit none
    interface csv_write
        module procedure csv_write_integer
        module procedure csv_write_integer_1d
        module procedure csv_write_integer_2d
        module procedure csv_write_char
        module procedure csv_write_char_1d
        module procedure csv_write_char_2d
        module procedure csv_write_real
        module procedure csv_write_real_1d
        module procedure csv_write_real_2d
        module procedure csv_write_dble
        module procedure csv_write_dble_1d
        module procedure csv_write_dble_2d
    end interface
contains


subroutine csv_next_record( lun )
    ! Go to the next record (convenience routine)
    !
    ! Result:
    !     The current record is closed, the next write will be to the
    !     new record
    ! Note:
    !     This is a convenience routine, it may result in a superfluous
    !     comma at the end of the previous record. This does not seem to
    !     be problematic, though, for MS Excel
    integer, intent(in)   :: lun ! LU-number of the CSV-file

    write(lun,'(a)') ''
end subroutine csv_next_record


! -----------------------------------------------------------------------------
! ------------------------------ 0D writing routines --------------------------
! -----------------------------------------------------------------------------

subroutine csv_write_integer( lun, value, advance )
    ! Write a single integer/real/double precision real to the CSV-file
    integer, intent(in)   :: lun ! LU-number of the CSV-file
    integer, intent(in)   :: value ! Value to write
    logical, intent(in)   :: advance ! Advance (.true.) or not, so that more items can be written to the same record

    character(len=40)     :: buffer
    write( buffer, '(I10)' ) value
    buffer = adjustl(buffer)
    if ( advance ) then
       write(lun,'(a)') trim(buffer)
    else
       ! Most probably: write the comma only when needed
       ! - depends on other actions
       write(lun,'(a,a)',advance='no') trim(buffer), ','
    endif
end subroutine csv_write_integer


subroutine csv_write_real( lun, value, advance )
    ! Write a single real to the CSV-file
    integer, intent(in)   :: lun ! LU-number of the CSV-file
    real, intent(in)   :: value ! Value to write
    logical, intent(in)   :: advance ! Advance (.true.) or not, so that more items can be written to the same record

    character(len=40)     :: buffer
    write( buffer, '(G14.6)' ) value
    buffer = adjustl(buffer)
    if ( advance ) then
       write(lun,'(a)') trim(buffer)
    else
       ! Most probably: write the comma only when needed
       ! - depends on other actions
       write(lun,'(a,a)',advance='no') trim(buffer), ','
    endif
end subroutine csv_write_real


subroutine csv_write_dble( lun, value, advance )
    ! Write a double to the CSV file
    integer, intent(in)   :: lun ! LU-number of the CSV-file
    real(kind=kind(1.0d0)), intent(in)     :: value ! Value to write
    logical, intent(in)   :: advance ! Advance (.true.) or not, so that more items can be written to the same record

    character(len=40)     :: buffer
    write( buffer, '(G20.12)' ) value
    buffer = adjustl(buffer)
    if ( advance ) then
       write(lun,'(a)') trim(buffer)
    else
       ! Most probably: write the comma only when needed
       ! - depends on other actions
       write(lun,'(a,a)',advance='no') trim(buffer), ','
    endif
end subroutine csv_write_dble


subroutine csv_write_char( lun, value, advance )
    ! Write a single character string to the CSV-file
    integer, intent(in)            :: lun ! LU-number of the CSV-file
    character(len=*), intent(in)   :: value ! Value to write
    logical, intent(in)   :: advance ! Advance (.true.) or not, so that more items can be written to the same record

    integer                        :: k
    integer                        :: pos
    integer                        :: posb
    character(len=2*len(value))    :: buffer

    buffer = value

    !
    ! Check for nasty characters (")
    !
    k    = index( value,'"')
    pos  = 1
    posb = 1
    do while ( k .ge. 1 )
        buffer(posb:)   = value(pos:)
        buffer(posb+k:) = '"' // value(pos+k:)
        pos             = pos  + k + 1
        posb            = posb + k + 2
        k               = index( value(pos:),'"')
    enddo

    if ( advance ) then
       write(lun,'(3a)') '"',trim(buffer),'"'
    else
       write(lun,'(3a,a)',advance='no') '"',trim(buffer), '"', ','
    endif
end subroutine csv_write_char


! -----------------------------------------------------------------------------
! ------------------------------ 1D writing routines --------------------------
! -----------------------------------------------------------------------------
!
! Note:
!     Because the four routines of this type differ only in
!     the data type, we use an include file for the body.

subroutine csv_write_integer_1d( lun, array, advance )
    ! Write a one-dimensional array of integer items to the CSV-file

    integer, dimension(:), intent(in)   :: array ! Array to write

    include 'csv_file_1d.f90'

end subroutine csv_write_integer_1d


subroutine csv_write_real_1d( lun, array, advance )
    ! Write a one-dimensional array of real items to the CSV-file

    real, dimension(:), intent(in)   :: array ! Array to write

    include 'csv_file_1d.f90'

end subroutine csv_write_real_1d


subroutine csv_write_dble_1d( lun, array, advance )
    ! Write a one-dimensional array of double items to the CSV-file

    real(kind=kind(1.0d0)), dimension(:), intent(in)   :: array ! Array to write

    include 'csv_file_1d.f90'

end subroutine csv_write_dble_1d


subroutine csv_write_char_1d( lun, array, advance )
    ! Write a one-dimensional array of character items to the CSV-file

    character(len=*), dimension(:), intent(in)   :: array ! Array to write

    include 'csv_file_1d.f90'

end subroutine csv_write_char_1d


! -----------------------------------------------------------------------------
! ------------------------------ 1D writing routines --------------------------
! -----------------------------------------------------------------------------
!
! Note:
!     Because the four routines of this type differ only in
!     the data type, we use an include file for the body.
subroutine csv_write_integer_2d( lun, array )
    ! Write a two-dimensional array of integer items to the CSV-file

    integer, dimension(:,:), intent(in)   :: array ! Array to write

    include 'csv_file_2d.f90'

end subroutine csv_write_integer_2d


subroutine csv_write_real_2d( lun, array )
    ! Write a two-dimensional array of real items to the CSV-file

    real, dimension(:,:), intent(in)   :: array ! Array to write

    include 'csv_file_2d.f90'

end subroutine csv_write_real_2d


subroutine csv_write_dble_2d( lun, array )
    ! Write a two-dimensional array of double items to the CSV-file

    real(kind=kind(1.0d0)), dimension(:,:), intent(in)   :: array ! Array to write

    include 'csv_file_2d.f90'

end subroutine csv_write_dble_2d


subroutine csv_write_char_2d( lun, array )
    ! Write a two-dimensional array of character items to the CSV-file

    character(len=*), dimension(:,:), intent(in)   :: array ! Array to write

    include 'csv_file_2d.f90'

end subroutine csv_write_char_2d

end module csv_file

module weathergenmod
    ! This module includes subroutines to calculate daily maximum and minimum temperature and cloud cover fraction
    ! based on an annual timeseries of monthly values of these variables
    ! The weather generator is based on the WGEN model (Richardson, 1981) with extension to use monthly summary
    ! data from Geng et al., 1986, and Geng and Auburn 1986.
    ! Additional statistical relationships for both temperature, cloudiness and wind speed have been produced
    ! by P.S. Sommer and J.O. Kaplan using global weather station datasets (GHCN and global synoptic cloud
    ! reports).
    !
    ! Coded in 2007-2009 by Jed Kaplan and Joe Melton, ARVE Group, EPFL/UVic, jed.kaplan@unil.ch,
    ! 2011, Shawn Koppenhoefer, shawn.koppenhoefer@unil.ch
    ! 2016, Philipp Sommer, philipp.sommer@unil.ch

    use parametersmod, only : sp,dp,i4
    use randomdistmod, only : randomstate


    implicit none

    public  :: metvars_in
    public  :: metvars_out
    public  :: rmsmooth
    public  :: weathergen

    private :: daymetvars
    private :: meansd

    !-------------------------------

    type metvars_in
        ! Derived datatype for the monthly weather generator input

        real(sp) :: prec    ! monthly total precipitation amount (mm)
        real(sp) :: wetd    ! number of days in month with precipitation
        real(sp) :: wetf    ! fraction of days in month with precipitation

        real(sp) :: tmin    ! minumum temperture (C)
        real(sp) :: tmax    ! maximum temperture (C)
        real(sp) :: cldf    ! cloud fraction (0=clear sky, 1=overcast) (fraction)
        real(sp) :: wind    ! wind speed (m/s)

        logical, dimension(2)  :: pday    !precipitation status: true if the day was a rain day
        type(randomstate)      :: rndst   !state of the random number generator
        real(sp), dimension(4) :: resid   !previous day's weather residuals

    end type metvars_in

    type metvars_out
        ! Derived datatype for the daily weather generator output

        real(sp) :: prec    ! 24 hour total precipitation (mm)
        real(sp) :: tmin    ! 24 hour mean minimum temperature (degC)
        real(sp) :: tmax    ! 24 hour mean maximum temperature (degC)
        real(sp) :: cldf    ! 24 hour mean cloud cover fraction 0=clear sky, 1=overcast (fraction)
        real(sp) :: wind    ! wind speed (m s-1)

        logical, dimension(2)  :: pday    !precipitation state
        type(randomstate)      :: rndst   !state of the random number generator, 15 elements
        real(sp), dimension(4) :: resid   !previous day's weather residuals
        real(sp) :: tmin_bias, wind_bias, wind_intercept_bias
        real(sp) :: tmin_mn, tmin_sd, wind_mn, wind_sd
        real(sp), dimension(4) :: unorm

    end type metvars_out

    type daymetvars
        ! Derived datatype for monthly climate variables

        real(sp) :: tmax_mn     ! maximum temperature monthly mean (degC)
        real(sp) :: tmin_mn     ! minimum temperature mothly mean (degC)
        real(sp) :: cldf_mn     ! mean cloud fraction (fraction)
        real(sp) :: wind_mn     ! wind speed

        real(sp) :: tmax_sd     ! standard deviation of corresponding variable above
        real(sp) :: tmin_sd     ! "
        real(sp) :: cldf_sd     ! "
        real(sp) :: wind_sd     ! "

    end type daymetvars

    ! -----------------------------------------------------------------------------
    ! ------------------- Defaults for the namelist parameters --------------------
    ! -----------------------------------------------------------------------------

    real(sp)                 :: thresh = 5.0 ! Threshold for transition from gamma to gp distribution

    logical :: thresh_pctl = .false. ! interpret the thresh as percentile
    ! coefficient to esimate the gamma scale parameter via
    ! g_scale = g_scale_coeff * mean_monthly_precip / number_of_wet_days
    ! following Geng et al., 1986
    real(sp)                 :: g_scale_coeff = 1.268022 ! coefficient to esimate the gamma scale parameter

    real(sp)                 :: gp_shape = 1.5 ! shape parameter for the Generalized Pareto distribution

    real(sp), dimension(4,4) :: A = reshape((/ & ! A matrix used for cross correlation following Richardson_1984 equation (4)
        0.913437, 0.032532,  -0.020658, 0.000573, &
        0.488761, 0.137304,  -0.07251,  -0.046058, &
        -0.00199, -0.04573,  0.591761,  0.026439, &
        0.010905, -0.044171, -0.018568, 0.666672 /), (/4, 4/))
    real(sp), dimension(4,4) :: B = reshape((/ & ! B matrix used for cross correlation following Richardson_1984 equation (4)
        0.361854, 0.0,       0.0,      0.0, &
        0.11441,  0.802987,  0.0,      0.0, &
        0.144862, -0.060622, 0.782791, 0.0, &
        0.080593, -0.015829, 0.066186, 0.736713/), (/4, 4/))

    ! transition probability correlations
    real(sp) :: p11_1 = 0.254877     ! intercept of p11 best line fit
    real(sp) :: p11_2 = 0.745123     ! slope of p11 best line fit
    real(sp) :: p101_1 = 0.0         ! intercept of p101 best line fit
    real(sp) :: p101_2 = 0.846326    ! slope of p101 best line fit
    real(sp) :: p001_1 = 0.0         ! intercept of p001 best line fit
    real(sp) :: p001_2 = 0.724019    ! slope of p001 best line fit

    ! temperature and cloud correlation parameters corresponding to wet or dry day
    ! minimum temperature regression results
    real(sp) :: tmin_w1 = 1.164653        ! intercept of best line fit of tmin on wet days (see :f:subr:`meansd`)
    real(sp) :: tmin_w2 = 0.955787        ! slope of best line fit of tmin on wet days (see :f:subr:`meansd`)
    real(sp) :: tmin_d1 = -0.528308       ! intercept of best line fit of tmin on dry days (see :f:subr:`meansd`)
    real(sp) :: tmin_d2 = 1.020964        ! slope of best line fit of tmin on dry days (see :f:subr:`meansd`)
    real(sp), dimension(3) :: tmin_sd_breaks = (/ -40., 0.0, 25. /)  ! breaks of tmin sd correlation
    ! polynomial coefficients for correlating tmin sd on wet days
    !   < -40       -40 - 0     0 - 25        > 25
    real(sp), dimension(4, 6) :: tmin_sd_w = reshape((/ &
        9.72715668, 3.05498827, 3.21874237,  0.55707042, &
        0.1010504, -0.21158825, -0.04507634, 0.02443123, &
        0.0,       0.01374948,  0.02094482,  0.0, &
        0.0,       0.00140538,  -0.00264577, 0.0, &
        0.0,       3.686e-05,   9.818e-05,   0.0, &
        0.0,       3.2e-07,     -1.13e-06,   0.0  &
        /), (/ 4, 6 /))
    ! polynomial coefficients for correlating tmin sd on dry days
    !   < -40        -40 - 0      0 - 25       > 25
    real(sp), dimension(4, 6) :: tmin_sd_d = reshape((/ &
        10.89900605, 3.56755661,  3.79411755,  -4.61943457, &
        0.12709893, -0.11544588,  0.03298697,  0.22605603, &
        0.0,         0.02824401, -0.01504554,  0.0, &
        0.0,         0.00195612,  0.00190346,  0.0, &
        0.0,         4.314e-05,  -0.00011362,  0.0, &
        0.0,         3.2e-07,     2.13e-06,    0.0 &
        /), (/ 4, 6 /))

    ! DEPRECEATED tmin parameters
    real(sp) :: tmin_sd_w1 = -9999.    ! DEPRECEATED. intercept of best line fit of std. dev. of tmin on wet days
    real(sp) :: tmin_sd_w2 = -9999.    ! DEPRECEATED. slope of best line fit of std. dev. of tmin on wet days
    real(sp) :: tmin_sd_d1 = -9999.    ! DEPRECEATED. intercept of best line fit of std. dev. of tmin on dry days
    real(sp) :: tmin_sd_d2 = -9999.    ! DEPRECEATED. slope of best line fit of tmin on dry days


    ! maximum temperature regression results
    real(sp) :: tmax_w1 = -0.586296       ! intercept of best line fit of tmax on wet days (see :f:subr:`meansd`)
    real(sp) :: tmax_w2 = 0.948669        ! slope of best line fit of tmax on wet days (see :f:subr:`meansd`)
    real(sp) :: tmax_d1 = 0.386508        ! intercept of best line fit of tmax on dry days (see :f:subr:`meansd`)
    real(sp) :: tmax_d2 = 1.0061          ! slope of best line fit of tmax on dry days (see :f:subr:`meansd`)
    real(sp), dimension(3) :: tmax_sd_breaks = (/ -30., 0.0, 35. /)  ! polynomial coefficients for the breaks of tmax sd correlation
    ! polynomial coefficients for correlating tmax sd on wet days
    !   < -30       -30 - 0       0 - 35       > 35
    real(sp), dimension(4, 6) :: tmax_sd_w = reshape((/ &
        6.67200351,  3.86010858,  3.79193207,  5.55292835, &
        0.03643908, -0.21861197, -0.03126021, -0.09734715, &
        0.0,         0.00388465,  0.01611473,  0.0, &
        0.0,         0.00146174, -0.00120298,  0.0, &
        0.0,         6.059e-05,   2.912e-05,   0.0, &
        0.0,         7.4e-07,    -2.4e-07,     0.0 &
        /), (/ 4, 6 /))
    ! polynomial coefficients for correlating tmax sd on dry days
    !   < -30       -30 - 0       0 - 35       > 35
    real(sp), dimension(4, 6) :: tmax_sd_d = reshape((/ &
        7.37455165,  4.61701866,  4.74550991,  3.25541815, &
        0.01535526, -0.33872824, -0.07609816, -0.02178605, &
        0.0,        -0.0187566,   0.01893058,  0.0, &
        0.0,        -0.0003185,  -0.00134943,  0.0, &
        0.0,         3.5e-06,     3.209e-05,   0.0, &
        0.0,         1.1e-07,    -2.5e-07,     0.0  &
        /), (/ 4, 6 /))
    ! DEPRECEATED tmax parameters
    real(sp) :: tmax_sd_w1 = -9999.    ! DEPRECEATED. intercept of best line fit of std. dev. of tmax on wet days
    real(sp) :: tmax_sd_w2 = -9999.    ! DEPRECEATED. slope of best line fit of std. dev. of tmax on wet days
    real(sp) :: tmax_sd_d1 = -9999.    ! DEPRECEATED. intercept of best line fit of std. dev. of tmax on dry days
    real(sp) :: tmax_sd_d2 = -9999.    ! DEPRECEATED. slope of best line fit of tmax on dry days


    ! cloud regression results
    real(sp) :: cldf_w = -0.738271    ! *a* parameter for cloud fit on wet days (see :f:subr:`meansd`)
    real(sp) :: cldf_d = 0.420534     ! *a* parameter for cloud fit on dry days (see :f:subr:`meansd`)
    real(sp) :: cldf_sd_w = 0.981917  ! *a* parameter for std. dev. of cloud fit on wet days (see :f:subr:`meansd`)
    real(sp) :: cldf_sd_d = 1.041732  ! *a* parameter for std. dev. of cloud fit on dry days (see :f:subr:`meansd`)

    ! wind regression results
    real(sp) :: wind_w1 = 0.0           ! intercept of best line fit of wind on wet days (see :f:subr:`meansd`)
    real(sp) :: wind_w2 = 1.092938      ! slope of best line fit of wind on wet days (see :f:subr:`meansd`)
    real(sp) :: wind_d1 = 0.0           ! intercept of best line fit of wind on dry days (see :f:subr:`meansd`)
    real(sp) :: wind_d2 = 0.945229      ! slope of best line fit of wind on wet days (see :f:subr:`meansd`)
    real(sp), dimension(6) :: wind_sd_w = (/ &  ! polygon coefficients for wind standard deviation on wet days
        0.0, 0.81840997, -0.12633931, 0.00933591, 0.0, 0.0 /)
    real(sp), dimension(6) :: wind_sd_d = (/ &  ! polygon coefficients for wind standard deviation on dry days
        0.0, 1.08596114, -0.24073323, 0.02216454, 0.0, 0.0 /)
    ! DEPRECEATED wind parameters
    real(sp) :: wind_sd_w1 = -9999.    ! DEPRECEATED. intercept of best line fit of std. dev. of wind on wet days
    real(sp) :: wind_sd_w2 = -9999.    ! DEPRECEATED. slope of best line fit of std. dev. of wind on wet days
    real(sp) :: wind_sd_d1 = -9999.    ! DEPRECEATED. intercept of best line fit of std. dev. wind on dry days
    real(sp) :: wind_sd_d2 = -9999.    ! DEPRECEATED. slope of best line fit of std. dev. wind on dry days

    ! wind bias correction (Note: Default is no correction)
    ! min. and max range for bias correction (1st and 99th percentile)
    real(sp) :: wind_bias_min = -2.3263478740, wind_bias_max = 2.3263478740 ! min. and max range for bias correction
    ! parameters for the exponential intercept correction
    real(sp) :: wind_intercept_bias_a = 1.1582245720322826  ! slope in the exponent
    real(sp) :: wind_intercept_bias_b = -1.3358916953022832  ! intercept in the exponent
    ! parameters of the slope - unorm best fit line
    ! coefficients for the bias correction of wind speed
    real(sp), dimension(6) :: wind_bias_coeffs = (/ &
         0.995353879899162,   0.8507947091050573, 0.027799823700343333, &
        -0.06710144300871658, 0.0,                0.0 /)
    real(sp), dimension(6) :: wind_intercept_bias_coeffs = 0.0
    ! Alternative slope bias correction using a logistic function
    real(sp) :: wind_slope_bias_L = -9999.   ! maximum value of logistic function of wind bias correction
    real(sp) :: wind_slope_bias_k = -9999.   ! steepness of logistic function of wind bias correction
    real(sp) :: wind_slope_bias_x0 = -9999.  ! x-value of sigmoid's midpoint of logistic function of wind bias correction

    ! coefficients for the bias correction of minimum temperature
    ! (Note: Default is no correction)
    real(sp), dimension(6) :: tmin_bias_coeffs = 0.0  ! coefficients for the bias correction of minimum temperature
    ! min. and max range for bias correction (1st and 99th percentile)
    real(sp) :: tmin_bias_min = -2.3263478740, tmin_bias_max = 2.3263478740 ! min. and max range for bias correction

    ! -----------------------------------------------------------------------------
    ! ------------------- END. Defaults for the namelist parameters ---------------
    ! -----------------------------------------------------------------------------

    ! the following parameters are computed by the cloud_params subroutine
    real(sp) :: cldf_w1, &
                cldf_w2, &
                cldf_w3, &
                cldf_w4, &
                cldf_d1, &
                cldf_d2, &
                cldf_d3, &
                cldf_d4

    contains

    !------------------------------------------------------------------------------------------------------------

    subroutine init_weathergen(f_unit)
        ! initialize the weather generator and read in the parameters from the
        ! namelist
        integer, intent(in), optional:: f_unit
        integer :: f_unit2 = 101

        namelist /weathergen_ctl/ &
            ! distribution parameters
            thresh, thresh_pctl, g_scale_coeff, gp_shape, &
            ! cross correlation coefficients
            A, B, &
            ! transition parameters
            p11_1, p11_2, p101_1, p101_2, p001_1, p001_2, &
            ! break points for tmin and tmax correlation
            tmin_sd_breaks, tmax_sd_breaks, &
            ! correlation parameters for wet days
            tmin_w1, tmin_w2, tmin_sd_w, tmax_w1, tmax_w2, tmax_sd_w, &
            cldf_w, cldf_sd_w, wind_w1, wind_w2, wind_sd_w, &
            ! correlation parameters for dry days
            tmin_d1, tmin_d2, tmin_sd_d, tmax_d1, tmax_d2, tmax_sd_d, cldf_d, &
            cldf_sd_d, wind_d1, wind_d2, wind_sd_d, &
            ! wind bias correction (Note: Default is no correction)
            wind_bias_coeffs, wind_intercept_bias_coeffs, wind_bias_min, wind_bias_max, &
            wind_slope_bias_L, wind_slope_bias_k, wind_slope_bias_x0, &
            wind_intercept_bias_a, wind_intercept_bias_b, &
            ! min. temperature bias correction (Note: Default is no correction)
            tmin_bias_coeffs, tmin_bias_min, tmin_bias_max, &
            ! depreceated parameters
            tmin_sd_w1, tmin_sd_w2, tmax_sd_w1, tmax_sd_w2, wind_sd_w1, wind_sd_w2, &
            tmin_sd_d1, tmin_sd_d2, tmax_sd_d1, tmax_sd_d2,  wind_sd_d1, wind_sd_d2
        if (.not. present(f_unit)) then
            open(f_unit2, file='weathergen.nml', status='old')
        else
            rewind f_unit
            f_unit2 = f_unit
        endif
        read(f_unit2, weathergen_ctl)
        if (.not. present(f_unit)) close(f_unit2)
        ! calculate cloud parameters
        call calc_cloud_params

        ! handle depreceated namelist parameters
        ! --------------------------------------
        ! tmin on wet days
        if (any(abs((/ tmin_sd_w1, tmin_sd_w2 /) + 9999.) > 1e-7)) then
            write (0, *) 'WARNING: Using depreceated tmin_sd_w1 and tmin_sd_w2 parameters! Use tmin_sd_w!'
            tmin_sd_w(:, :) = 0.
            tmin_sd_breaks(:) = 9999.
            tmin_sd_w(1, 1) = tmin_sd_w1
            tmin_sd_w(1, 2) = tmin_sd_w2
        end if
        ! tmin on dry days
        if (any(abs((/ tmin_sd_d1, tmin_sd_d2 /) + 9999.) > 1e-7)) then
            write (0, *) 'WARNING: Using depreceated tmin_sd_d1 and tmin_sd_d2 parameters! Use tmin_sd_d!'
            tmin_sd_d(:, :) = 0.
            tmin_sd_breaks(:) = 9999.
            tmin_sd_d(1, 1) = tmin_sd_d1
            tmin_sd_d(1, 2) = tmin_sd_d2
        end if
        ! tmax on wet days
        if (any(abs((/ tmax_sd_w1, tmax_sd_w2 /) + 9999.) > 1e-7)) then
            write (0, *) 'WARNING: Using depreceated tmax_sd_w1 and tmax_sd_w2 parameters! Use tmax_sd_w!'
            tmax_sd_w(:, :) = 0.
            tmax_sd_breaks(:) = 9999.
            tmax_sd_w(1, 1) = tmax_sd_w1
            tmax_sd_w(1, 2) = tmax_sd_w2
        end if
        ! tmax on dry days
        if (any(abs((/ tmax_sd_d1, tmax_sd_d2 /) + 9999.) > 1e-7)) then
            write (0, *) 'WARNING: Using depreceated tmax_sd_d1 and tmax_sd_d2 parameters! Use tmax_sd_d!'
            tmax_sd_d(:, :) = 0.
            tmax_sd_breaks(:) = 9999.
            tmax_sd_d(1, 1) = tmax_sd_d1
            tmax_sd_d(1, 2) = tmax_sd_d2
        end if
        ! wind on wet days
        if (any(abs((/ wind_sd_w1, wind_sd_w2 /) + 9999.) > 1e-7)) then
            write (0, *) 'WARNING: Using depreceated wind_sd_w1 and wind_sd_w2 parameters! Use wind_sd_w!'
            wind_sd_w(:) = 0.
            wind_sd_w(1) = wind_sd_w1
            wind_sd_w(2) = wind_sd_w2
        end if
        ! wind on dry days
        if (any(abs((/ wind_sd_d1, wind_sd_d2 /) + 9999.) > 1e-7)) then
            write (0, *) 'WARNING: Using depreceated wind_sd_d1 and wind_sd_d2 parameters! Use wind_sd_d!'
            wind_sd_d(:) = 0.
            wind_sd_d(1) = wind_sd_d1
            wind_sd_d(2) = wind_sd_d2
        end if
    end subroutine init_weathergen

    !------------------------------------------------------------------------------------------------------------

    subroutine weathergen(met_in,met_out)

        use parametersmod, only : sp,dp,tfreeze
        use randomdistmod, only : ranur,ran_normal,ran_gamma_gp,ran_gamma, &
                                  gamma_cdf, gamma_pdf, gamma_cdf_inv

        implicit none

        !---------------
        !arguments

        type(metvars_in),  intent(in)  :: met_in
        type(metvars_out), intent(out) :: met_out

        !---------------
        !local variables

        integer  :: i

        real(sp) :: pre    ! monthly total precipitation amount (mm)
        real(sp) :: wetd   ! number of days in month with precipitation (fraction)
        real(sp) :: wetf   ! fraction of days in month with precipitation (fraction)
        real(sp) :: tmn    ! minumum temperture (C)
        real(sp) :: tmx    ! maximum temperture (C)
        real(sp) :: cld    ! cloud fraction (0=clear sky, 1=overcast) (fraction)
        real(sp) :: wnd    ! wind (m/s)

        real(sp), pointer :: tmax_mn
        real(sp), pointer :: tmin_mn
        real(sp), pointer :: cldf_mn
        real(sp), pointer :: wind_mn
        real(sp), pointer :: tmax_sd
        real(sp), pointer :: tmin_sd
        real(sp), pointer :: cldf_sd
        real(sp), pointer :: wind_sd

        type(randomstate) :: rndst       ! integer state of the random number generator
        logical,  dimension(2) :: pday   ! element for yesterday and the day before yesterday
        real(sp), dimension(4) :: resid  ! previous day's weather residuals

        real(sp) :: prec
        real(sp) :: tmin
        real(sp) :: tmax
        real(sp) :: cldf
        real(sp) :: wind

        real(sp) :: pbar     ! mean amount of precipitation per wet day (mm)
        real(sp) :: pwet     ! probability that today will be wet
        real(sp) :: u        ! uniformly distributed random number (0-1)

        real(sp) :: g_shape
        real(sp) :: g_scale
        real(sp) :: gp_scale
        real(sp) :: thresh2use

        ! bias correction
        real(sp) :: slopecorr      ! slope correction for wind
        real(sp) :: intercept_corr ! intercept correction for wind
        real(sp) :: tmin_bias      ! intercept correction for tmin

        real(kind=8) :: cdf_thresh  ! gamma cdf at the threshold
        real(kind=8) :: pdf_thresh  ! gamma pdf at the threshold

        type(daymetvars), target :: dmetvars

        real(sp), dimension(4) :: unorm  ! vector of uniformly distributed random numbers (0-1)

        !---------------------------------------------------------
        !input

        pre   = met_in%prec
        wetd  = met_in%wetd
        wetf  = met_in%wetf
        tmn   = met_in%tmin
        tmx   = met_in%tmax
        cld   = met_in%cldf
        wnd  = met_in%wind
        rndst = met_in%rndst
        pday  = met_in%pday
        resid = met_in%resid

        !shorthand to mean and CV structure

        tmin_mn => dmetvars%tmin_mn
        tmax_mn => dmetvars%tmax_mn
        cldf_mn => dmetvars%cldf_mn
        wind_mn => dmetvars%wind_mn
        tmin_sd => dmetvars%tmin_sd
        tmax_sd => dmetvars%tmax_sd
        cldf_sd => dmetvars%cldf_sd
        wind_sd => dmetvars%wind_sd

        !---------------------------
        !1) Precipitation occurrence

        !if there is precipitation this month, calculate the precipitation state for today

        if (wetf > 0. .and. pre > 0.) then

            !calculate transitional probabilities for dry to wet and wet to wet days
            !Relationships from Geng & Auburn, 1986, Weather simulation models based on summaries of long-term data

            if (pday(1)) then !yesterday was raining, use p11

                pwet = p11_1 + p11_2 * wetf

            else if (pday(2)) then !yesterday was not raining but the day before yesterday was raining, use p101

                pwet = p101_1 + p101_2 * wetf

            else  !both yesterday and the day before were dry, use p001

                pwet = p001_1 + p001_2 * wetf

            end if

            ! -----
            ! determine the precipitation state of the current day using the Markov chain approach
            u = ranur(rndst)

            if (u <= pwet) then  !today is a rain day

                pday = eoshift(pday,-1,.true.)

            else  !today is dry

                pday = eoshift(pday,-1,.false.)

            end if

            !---------------------------
            !2) precipitation amount

            if (pday(1)) then  !today is a wet day, calculate the rain amount

                !calculate parameters for the distribution function of precipitation amount

                pbar = pre / wetd

                !if (pbar > pmin) then
                !  g_scale = -2.16 + 1.83 * pbar !original relationship from Geng 1986
                !else
                !  g_scale = pbar
                !end if

                g_scale = g_scale_coeff * pbar
                g_shape = pbar / g_scale

                if (thresh_pctl) then
                    thresh2use = gamma_cdf_inv(real(thresh, kind=8), real(g_shape, kind=8), real(g_scale, kind=8))
                else
                    thresh2use = thresh
                end if

                call gamma_cdf(real(thresh2use, kind=8), 0.0_dp, real(g_scale, kind=8), &
                               real(g_shape, kind=8), cdf_thresh)
                call gamma_pdf(real(thresh2use, kind=8), 0.0_dp, real(g_scale, kind=8), &
                               real(g_shape, kind=8), pdf_thresh)

                gp_scale = (1.0 - cdf_thresh)/ pdf_thresh

                do  i=1,1000!enforce positive precipitation

                    !today's precipitation

                    prec = ran_gamma_gp(rndst,.true.,g_shape,g_scale,thresh2use,gp_shape,gp_scale)

                    prec = roundto(prec,1)    !simulated precipitation should have no more precision than the input (0.1mm)

                    if (prec > 0. .and. prec <= 1.05 * pre) exit

                    if (i == 1000) then
                        write (0, *) 'Could not find good precipitation with ', pre, ' mm and ', wetd, ' wet days'
                        stop 1
                    end if

                end do

            else

                prec = 0.

            end if

        else

            pday = .false.
            prec = 0.

        end if

        !---------------------------

        !3) temperature min and max, cloud fraction

        !calculate a baseline mean and SD for today's weather dependent on precip status

        call meansd(pday(1),tmn,tmx,cld,wnd,  dmetvars)

        ! use random number generator for the normal distribution

        do i = 1,4
            call ran_normal(rndst,unorm(i))
        end do

        !calculate today's residuals for weather variables

        resid = matmul(A,resid) + matmul(B,unorm)  !Richardson 1981, eqn 5; WGEN tech report eqn. 3

        tmin = roundto(resid(1) * tmin_sd + tmin_mn,1)
        tmax = roundto(resid(2) * tmax_sd + tmax_mn,1)

        cldf = resid(3) * cldf_sd + cldf_mn

        wind = max(0.0, resid(4) * sqrt(max(0.0, wind_sd)) + sqrt(max(0.0, wind_mn)))

        wind = roundto(wind * wind, 1)

        ! ---- wind bias correction
        if (wind_slope_bias_L > 0.0) then
            slopecorr = wind_slope_bias_L / ( 1 + exp( - wind_slope_bias_k * ( &
                resid(4) - wind_slope_bias_x0)))
        else
            slopecorr = sum(wind_bias_coeffs(:) * ( &
                max(wind_bias_min, min(wind_bias_max, resid(4))) ** (/ 0, 1, 2, 3, 4, 5 /)))
        end if

        if (abs(wind_intercept_bias_a + 9999.) > 1e-7) then
            intercept_corr = exp(wind_intercept_bias_b + &
                wind_intercept_bias_a * max(wind_bias_min, min(wind_bias_max, resid(4))))
        else
            intercept_corr = sum(wind_intercept_bias_coeffs(:) * ( &
                max(wind_bias_min, min(wind_bias_max, resid(4))) ** (/ 0, 1, 2, 3, 4, 5 /)))
        end if

        wind = (wind - intercept_corr) / max(slopecorr, 9e-4)

        ! ----- tmin bias correction
        tmin_bias = sum(tmin_bias_coeffs(:) * ( &
            max(tmin_bias_min, min(tmin_bias_max, resid(1))) ** (/ 0, 1, 2, 3, 4, 5 /)))
        tmin = tmin - roundto(tmin_bias, 1)


        !---
        !add checks for invalid values here
        if (cldf>1) then
            cldf = 1.0
        elseif (cldf < 0.0) then
            cldf = 0.0
        end if

        if (wind<0) then
            wind = 0.0
        end if

        if (tmin+Tfreeze < 0.) then
            write(0,*)'Unphysical min. temperature with ', tmin, 'K from a monthly mean ', &
                tmin_mn, 'degC with bias correction ', tmin_bias, 'K for residual', resid(1)
            stop 1
        elseif (tmax+Tfreeze < 0.) then
            write(0,*)'Unphysical max. temperature with ', tmax, 'K from a monthly mean ', &
                tmax_mn, 'degC'
            stop 1
        end if

        !---

        met_out%prec  = prec
        met_out%tmin  = tmin
        met_out%tmax  = tmax
        met_out%cldf  = cldf
        met_out%wind  = wind
        met_out%pday  = pday
        met_out%rndst = rndst
        met_out%resid = resid
        met_out%tmin_bias = tmin_bias
        met_out%tmin_mn = tmin_mn
        met_out%tmin_sd = tmin_sd
        met_out%wind_bias = slopecorr
        met_out%wind_intercept_bias = intercept_corr
        met_out%wind_mn = wind_mn
        met_out%wind_sd = wind_sd
        met_out%unorm = unorm

    end subroutine weathergen

    !------------------------------------------------------------------------------------------------------------

    subroutine meansd(pday,tmn,tmx,cld,wind,dm)
        ! Adjust the monthly means of temperature, cloud and wind corresponding to the wet/dry state
        !
        ! This routine makes the first approximation inside the weather generator to adjust the monthly
        ! mean according to the wet/dry state using the best fit lines from the parameterization.
        !
        ! Min. and max. temperature, as well as the wind speed, are calculated via
        !
        ! .. math::
        !
        !     x_{w/d} = x_{w/d1} + x_{w/d2} \cdot \bar{x}
        !
        ! Where :math:`x` stands either for the :math:`T_{min}, T_{max}, T_{min, sd}, T_{max, sd}, wind`
        ! or :math:`wind_{sd}`. :math:`w/d` stands for the wet dry state deterimined by `pday`.
        !
        ! The cloud fraction is calculated via
        !
        ! .. math::
        !
        !     c_{w/d} = \frac{-a_{w/d} - 1}{a_{w/d}^2 * \bar{c} - a_{w/d}^2 - a_{w/d}}  - \frac{1}{a_{w/d}}
        !
        ! and it's standard deviation via
        !
        ! .. math::
        !
        !     c_{sd, w/d} = a_{sd, w/d}^2 \cdot c_{w/d} \cdot (1 - c_{w/d})
        implicit none

        logical,          intent(in)  :: pday    ! precipitation status (mm/day)
        real(sp),         intent(in)  :: tmn     ! smooth interpolation of monthly minimum temperature (degC)
        real(sp),         intent(in)  :: tmx     ! smooth interpolation of monthly maximum temperature (degC)
        real(sp),         intent(in)  :: cld     ! fraction (0-1)
        real(sp),         intent(in)  :: wind    ! wind speed (m/s)
        type(daymetvars), intent(out) :: dm      ! the :f:type:`daymetvars` for the first daily approximation

        !local variables

        !---

        if (pday) then  !calculate mean and SD for a wet day

            dm%tmin_mn = tmin_w1 + tmin_w2 * tmn

            dm%tmax_mn = tmax_w1 + tmax_w2 * tmx

            dm%wind_mn = wind_w1 + wind_w2 * wind

            dm%cldf_mn = cldf_w1 / (cldf_w2 * cld + cldf_w3) + cldf_w4

            dm%wind_sd = sum(wind_sd_w * (dm%wind_mn ** (/ 0, 1, 2, 3, 4, 5 /)))

            dm%cldf_sd = cldf_sd_w * dm%cldf_mn * (1. - dm%cldf_mn)

        else  !dry day

            dm%tmin_mn = tmin_d1 + tmin_d2 * tmn

            dm%tmax_mn = tmax_d1 + tmax_d2 * tmx

            dm%wind_mn = wind_d1 + wind_d2 * wind

            dm%cldf_mn = cldf_d1 / (cldf_d2 * cld + cldf_d3) + cldf_d4

            dm%wind_sd = sum(wind_sd_d * (dm%wind_mn ** (/ 0, 1, 2, 3, 4, 5 /)))

            dm%cldf_sd = cldf_sd_d * dm%cldf_mn * (1. - dm%cldf_mn)

        end if

        call temp_sd(pday, dm)

    end subroutine meansd

    !----------------------------------------------------------------------------------------------------------------

    subroutine rmsmooth(m,dmonth,bcond,r)
        ! Iterative, mean preserving method to smoothly interpolate mean data to pseudo-sub-timestep values
        ! From Rymes, M.D. and D.R. Myers, 2001. Solar Energy (71) 4, 225-231

        use parametersmod, only : sp

        implicit none

        !arguments
        real(sp), dimension(:), intent(in)  :: m      ! vector of mean values at super-time step (e.g., monthly), minimum three values
        integer,  dimension(:), intent(in)  :: dmonth ! vector of number of intervals for the time step (e.g., days per month)
        real(sp), dimension(2), intent(in)  :: bcond  ! boundary conditions for the result vector (1=left side, 2=right side)
        real(sp), dimension(:), intent(out) :: r      ! result vector of values at chosen time step

        !parameters
        real(sp), parameter :: ot = 1. / 3

        !local variables
        integer :: n
        integer :: ni
        integer :: a
        integer :: b
        integer :: i
        integer :: j
        integer :: k
        integer :: l
        integer, dimension(size(r)) :: g
        real(sp) :: ck

        real(sp), dimension(2) :: bc

        !----------

        n  = size(m)
        ni = size(r)

        bc = bcond

        !initialize the result vector
        i = 1
        do a = 1,n
            j = i
            do b = 1,dmonth(a)
                r(i) = m(a)
                g(i) = j
                i = i + 1
            end do
        end do

        !iteratively smooth and correct the result to preserve the mean

        !iteration loop
        do i = 1,ni

            do j = 2,ni-1
                r(j) = ot * (r(j-1) + r(j) + r(j+1))   !Eqn. 1
            end do

            r(1)  = ot * (bc(1)   + r(1)  +  r(2))   !Eqns. 2
            r(ni) = ot * (r(ni-1) + r(ni) + bc(2))

            j = 1
            do k = 1,n                               !calculate one correction factor per super-timestep

                a = g(j)                               !index of the first timestep value of the super-timestep
                b = g(j) + dmonth(k) - 1               !index of the last timestep value of the super-timestep

                ck = sum(m(k) - r(a:b)) / ni           !Eqn. 4

                do l = 1,dmonth(k)                     !apply the correction to all timestep values in the super-timestep
                    r(j) = r(j) + ck
                    j = j + 1
                end do

                !correction for circular conditions when using climatology (do not use for transient simulations)
                bc(1) = r(ni)
                bc(2) = r(1)

            end do
        end do

    end subroutine rmsmooth

    !-----------------------------------------------------------------------

    real(sp) function roundto(val,precision)
        ! round a value to the given precision

        implicit none

        real(sp), intent(in) :: val  ! the input value
        integer,  intent(in) :: precision  ! the precision

        real(sp) :: scale

        !----

        scale = 10.**precision

        roundto = real(nint(val * scale)) / scale

    end function roundto

    !------------------------------------------------------------------------------------------------------------

    subroutine calc_cloud_params
        ! Calculate the parameters used for the first approximation in :f:subr:`meansd`
        !
        ! This subroutine uses :f:var:`cldf_w`, :f:var:`cldf_d`, :f:var:`cldf_sd_w` and
        ! :f:var:`cldf_sd_d` to calculate the necessary parameters for the adjustment of
        ! the monthly cloud fraction mean depending on the wet/dry state

        cldf_w1 = -cldf_w - 1.0
        cldf_w2 = cldf_w * cldf_w
        cldf_w3 = -(cldf_w * cldf_w) - cldf_w
        cldf_w4 = - 1.0/cldf_w
        cldf_sd_w = cldf_sd_w * cldf_sd_w

        cldf_d1 = -cldf_d - 1.0
        cldf_d2 = cldf_d * cldf_d
        cldf_d3 = -(cldf_d * cldf_d) - cldf_d
        cldf_d4 = - 1.0/cldf_d
        cldf_sd_d = cldf_sd_d * cldf_sd_d

    end subroutine calc_cloud_params

    subroutine temp_sd(pday, dm)

        logical,          intent(in)  :: pday    ! precipitation status (mm/day)
        type(daymetvars), intent(inout) :: dm
        integer :: i

        do i=1,4
            if (i == 4 .or. dm%tmin_mn <= tmin_sd_breaks(i)) then
                if (pday) then
                    dm%tmin_sd = sum(tmin_sd_w(i, :) * (dm%tmin_mn ** (/ 0, 1, 2, 3, 4, 5 /)))
                else
                    dm%tmin_sd = sum(tmin_sd_d(i, :) * (dm%tmin_mn ** (/ 0, 1, 2, 3, 4, 5 /)))
                end if
                exit
            endif
        end do
        do i=1,4
            if (i == 4 .or. dm%tmax_mn <= tmax_sd_breaks(i)) then
                if (pday) then
                    dm%tmax_sd = sum(tmax_sd_w(i, :) * (dm%tmax_mn ** (/ 0, 1, 2, 3, 4, 5 /)))
                else
                    dm%tmax_sd = sum(tmax_sd_d(i, :) * (dm%tmax_mn ** (/ 0, 1, 2, 3, 4, 5 /)))
                end if
                exit
            endif
        end do

    end subroutine temp_sd

end module weathergenmod

! cvs_file_2d.f90 --
!     Include file for csv_file.f90:
!     contains the body of the two-dimensional version of the
!     writing routines.
!
!     $Id: csv_file_2d.f90,v 1.2 2006/03/26 19:03:53 arjenmarkus Exp $
!
    integer, intent(in)                 :: lun ! LU-number of the CSV-file

    logical                             :: adv
    integer                             :: i

    adv = .true.

    do i = 1,size(array,2)
        call csv_write( lun, array(:,i), adv )
    enddo
!
! end of body

module randomdistmod
    ! Random number generators and distributions module
    !
    ! This module contains subroutines and functions to compute the gamma and
    ! normal distribution, as well as a random number generator. Most of the
    ! subroutines have been translated from other languages to FORTRAN. The main
    ! references are
    !
    ! - http://www.johndcook.com/SimpleRNG.cpp for the random number generators
    ! - http://people.sc.fsu.edu/~jburkardt/f_src/prob/prob.html by John
    !   Burkardt for the gamma and normal distribution functions

    use parametersmod, only : sp, i4

    implicit none

    public  :: ran_seed
    public  :: ranur
    public  :: ran_normal
    public  :: ran_gamma
    public  :: gamma_cdf
    public  :: gamma_pdf

    private :: refill

    !----------------
    !module variables

    integer(i4), parameter :: qsiz  = 10   !41265_i4
    integer(i4), parameter :: cmul  = 69609_i4
    integer(i4), parameter :: coffs =   123_i4

    real(sp), parameter :: rng1 = 1. / (2. * real(huge(i4)))  !scales the random integer to -0.5,0.5
    real(sp), parameter :: rng2 = 1. / real(huge(i4))         !scales the random integer to -1,1

    real(sp), parameter :: one    = 1.
    real(sp), parameter :: half   = 0.5
    real(sp), parameter :: vsmall = tiny(1.)
    real(sp), parameter :: zero   = 0.

    type randomstate
        integer(i4), dimension(qsiz) :: q
        integer(i4) :: carry =       362_i4
        integer(i4) :: xcng  =   1236789_i4
        integer(i4) :: xs    = 521288629_i4  !default seed
        integer(i4) :: indx  = qsiz + 1
        logical     :: have  = .false.
    end type randomstate  !5+qsiz elements = 15 elements

    contains

    !-----------------------------------------------------------------------

    integer(i4) function ranu(state)
        ! Generates a uniformly distributed random 4 byte integer with the range (-huge(i4),+huge(i4))
        ! based on the 32-bit super KISS random number generator by George Marsaglia, published online
        ! and translated to Fortran 90 by user "mecej4" and Marsaglia, http://forums.silverfrost.com/viewtopic.php?t=1480
        ! Further modifications to pass the complete state of the generator as an argument by J.O. Kaplan, 2011

        implicit none

        type(randomstate), target, intent(inout) :: state ! state of the uniform random number generator

        integer(i4) :: supr

        integer(i4), pointer :: indx
        integer(i4), pointer :: xcng
        integer(i4), pointer :: xs
        integer(i4), pointer, dimension(:) :: q

        !---------------------

        indx => state%indx
        q    => state%q
        xcng => state%xcng
        xs   => state%xs

        !---

        if (indx <= qsiz) then
            supr = q(indx)
            indx = indx + 1
        else                     !reset the generator
            supr = refill(state)
        end if

        !---

        xcng = xcng * cmul + coffs
        xs   = ieor(xs,ishft(xs, 13))
        xs   = ieor(xs,ishft(xs,-17))
        xs   = ieor(xs,ishft(xs, -5))

        ranu = xcng + xs + supr

    end function ranu

    !-----------------------------------------------------------------------

    real(sp) function ranur(state)
        ! generate a random number in the range (0,1)

        implicit none

        type(randomstate), target, intent(inout) :: state ! state of the uniform random number generator

        !----

        ranur = real(ranu(state)) * rng1 + half

    end function ranur

    !-----------------------------------------------------------------------

    function refill(state) result(s)
        ! reset a random state

        implicit none

        type(randomstate), target, intent(inout) :: state ! state of the uniform random number generator

        integer(i4) :: s
        integer(i4) :: z
        integer(i4) :: h

        integer     :: i

        integer(i4), pointer :: indx
        integer(i4), pointer :: carry
        integer(i4), pointer, dimension(:) :: q

        !---------------------

        indx  => state%indx
        carry => state%carry
        q     => state%q

        !---

        do i = 1,qsiz

            h = iand(carry,1_i4)
            z = ishft(ishft(q(i),9),-1) + ishft(ishft(q(i),7),-1) + ishft(carry,-1)

            carry = ishft(q(i),-23) + ishft(q(i),-25) + ishft(z,-31)

            q(i) = not(ishft(z,1)+h)

        end do

        indx = 2
        s = q(1)

    end function refill

    !-----------------------------------------------------------------------

    subroutine ran_seed(sval,state)
        ! Set the seed of the random state

        implicit none

        integer(i4),               intent(in)    :: sval  ! state of the uniform random number generator
        type(randomstate), target, intent(inout) :: state ! the random state

        integer     :: i

        integer(i4), pointer :: xcng
        integer(i4), pointer :: xs
        integer(i4), pointer, dimension(:) :: q

        !---------------------

        q    => state%q
        xcng => state%xcng
        xs   => state%xs

        xs = sval

        !---

        do i = 1,qsiz

            xcng = xcng * cmul + coffs
            xs = ieor(xs,ishft(xs, 13))
            xs = ieor(xs,ishft(xs,-17))
            xs = ieor(xs,ishft(xs, -5))
            q(i) = xcng + xs

        end do

    end subroutine ran_seed

    !-----------------------------------------------------------------------

    subroutine ran_normal(state,nval)
        ! Sampler for the normal distribution centered at 0 with std. dev. of unity,
        ! based on Marsaglia polar method

        implicit none

        type(randomstate), intent(inout) :: state ! state of the uniform random number generator
        real(sp),          intent(out)   :: nval  ! output: The random number from the normal distribution

        !---

        real(sp), dimension(2) :: vals

        integer(i4), dimension(2) :: u
        real(sp),    dimension(2) :: v

        real(sp) :: s
        real(sp) :: a

        !---------------------

        do

            u(1) = ranu(state)
            u(2) = ranu(state)

            v = real(u) * rng2   !convert integer (-huge,+huge) to (-1,+1)

            s = sum(v**2)

            if (s < 1.) exit

        end do

            a = sqrt(-2. * log(s) / s)

            vals = v * a

        if (state%have) then

            state%have = .false.
            nval = vals(2)

        else

            nval = vals(1)
            state%have = .true.

        end if

    end subroutine ran_normal

    !----------------------------------------------------------------------------------------------------------

    real(sp) recursive function ran_gamma(state,first,shape,scale) result(ret)
        ! Select a random number from a Gamma distribution
        !
        ! adapted from the cpp adaptation of the Marsaglia & Tsang random gamma algorithm in:
        ! http://www.johndcook.com/SimpleRNG.cpp
        !
        ! Uses the algorithm in
        ! Marsaglia, G. and Tsang, W.W. (2000), *A simple method for generating
        ! gamma variables*, Trans. om Math. Software (TOMS), vol.26(3), pp.363-372.

        implicit none

        !arguments

        type(randomstate), intent(inout) :: state  ! state of the uniform random number generator
        logical,           intent(in)    :: first  ! flag if this is the first call to the distribution with this shape
        real(sp),          intent(in)    :: shape  ! shape parameter of the Gamma distribution (k or alpha, unitless) > 0
        real(sp),          intent(in)    :: scale  ! scale parameter of the Gamma distribution (theta = 1/beta)

        !local variables

        real(sp), save  :: c
        real(sp), save  :: d
        real(sp)        :: u
        real(sp)        :: v
        real(sp)        :: x

        !--------

        if (shape <= 0.) then

            write(0,*) 'shape parameter value must be positive'
            stop

        else if (shape >= 1.) then

            if (first) then
                d = shape - 1. / 3.
                c = 1. / sqrt(9. * d)
            end if

            do

                do  !generate v = (1+cx)^3 where x is random normal; repeat if v <= 0.

                  call ran_normal(state,x)
                  v = (1. + c * x)**3
                  if (v > 0.) exit

                end do

                u = ranur(state)  ! generate uniform variable u in the range (0,1)

                if (u < 1. - 0.0331 * x**4 .or. log(u) < half * x**2 + d*(1. - v + log(v))) then
                  ret = scale * d * v
                  exit
                end if
            end do

        else

            ret = scale * ran_gamma(state,first,shape + 1.,1.) * ranur(state)**(1. / shape)

        end if

    end function ran_gamma

    !----------------------------------------------------------------------------------------------------------

    real(sp) function ran_gamma_gp(state,first,shape,scale,thresh,shape_gp,scale_gp) result(ret)
        ! Select a random number from a hybrid Gamma-GP distribution

        implicit none

        !arguments

        type(randomstate), intent(inout) :: state     ! state of the uniform random number generator
        logical,           intent(in)    :: first     ! flag if this is the first call to the distribution with this shape
        real(sp),          intent(in)    :: shape     ! shape parameter of the Gamma distribution (k or alpha, unitless) > 0
        real(sp),          intent(in)    :: scale     ! scale parameter of the Gamma distribution (theta = 1/beta)
        real(sp),          intent(in)    :: thresh    ! the threshold above which to choose the GP distribution
        real(sp),          intent(in)    :: shape_gp  ! shape parameter of the GP distribution
        real(sp),          intent(in)    :: scale_gp  ! scale parameter of the GP distribution

        ret = ran_gamma(state,first,shape,scale)
        if (ret > thresh) then
            ret = ran_gp(state,shape_gp,scale_gp,thresh)
        endif

    end function ran_gamma_gp

    !-------------------------------

    real(sp) function ran_gp(state,shape,scale,loc)
        ! Select a random number from a generalized pareto (GP) distribution

        implicit none

        type(randomstate), intent(inout) :: state  ! state of the uniform random number generator
        real(sp),          intent(in)    :: shape  ! shape parameter of the GP distribution (k or alpha, unitless) > 0
        real(sp),          intent(in)    :: scale  ! scale parameter of the GP distribution (theta = 1/beta)
        real(sp),          intent(in)    :: loc    ! the location of the GP distribution

        real(sp)        :: u

        u = ranur(state)  ! generate uniform variable u in the range (0,1)

        if (shape == 0.0_sp) then
            ran_gp = loc - scale * log(u)
        else
            ran_gp = loc + scale * (U**(-shape) - 1) / shape
        endif

    end function ran_gp

    ! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    ! -------------------------------------------------------------------------
    ! --------- Subroutines for gamma distribution and density functions ------
    ! -------------------------------------------------------------------------
    ! +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

    ! The following functions and subroutines are taken from R, version 3.3.2 and
    ! converted from the original src/nmath/qgamma.c to fortran by Philipp Sommer,
    ! 2016, November 26th


    real(kind = 8) function qchisq_appr(p, nu, g, tol)
        ! chi-square approximation for the :f:func:`gamma_cdf_inv` function

        real(kind = 8), intent(in) :: p   ! the quantile
        real(kind = 8), intent(in) :: nu  ! twice the gamma shape
        real(kind = 8), intent(in) :: g   ! the logarithm of the gamma function at the gamma shape
        real(kind = 8), intent(in) :: tol ! the tolerance for the approximation

        real(kind = 8) :: alpha, a, c, ch, p1
        real(kind = 8) :: p2, q, t, x, lgam1pa

        alpha = 0.5 * nu
        c = alpha - 1.0

        p1 = log(p)

        if (nu < (-1.24) * p1) then
            ! for small chi-squared */
            !    log(alpha) + g = log(alpha) + log(gamma(alpha)) =
            !       = log(alpha*gamma(alpha)) = lgamma(alpha+1) suffers from
            !    catastrophic cancellation when alpha << 1
            if (alpha < 0.5) then
                lgam1pa = gamma_log(alpha + 1.0)
            else
                lgam1pa = log(alpha) + g
            end if
            ch = exp((lgam1pa + p1)/alpha + log(2.0))
        else if (nu > 0.32) then !  using Wilson and Hilferty estimate
            call normal_cdf_inv(p, real(0.0, kind=8), real(1.0, kind=8), x)
            p1 = 2. / (9.0 * nu)
            ch = nu * (x * sqrt(p1) + 1.0 - p1) ** 3
            ! approximation for p tending to 1:
            if (ch > 2.2 * nu + 6) ch = -2.0 * (log(1 - p) - c * log(0.5 * ch) + g)
        else
            ch = 0.4
            a = log(1 - p) + g + c * log(2.0)
            do while (abs(q - ch) > tol * abs(ch))
                q = ch
                p1 = 1. / (1 + ch * (4.67 + ch))
                p2 = ch * (6.73 + ch * (6.66 + ch))
                t = -0.5 + (4.67 + 2 * ch) * p1 - (6.73 + ch*(13.32 + 3 * ch)) / p2
                ch = ch - (1 - exp(a + 0.5 * ch) * p2 * p1) / t
            end do
        end if
        qchisq_appr = ch

    end function qchisq_appr

    !-------------------------------

    real(kind = 8) function gamma_cdf_inv(p, alpha, scale)
        !	Compute the quantile function of the gamma distribution.
        !
        ! This function is based on the Applied Statistics Algorithm AS 91
        ! ("ppchi2") and via pgamma(.) AS 239.
        !
        ! References
        !	    Best, D. J. and D. E. Roberts (1975).
        !	    Percentage Points of the Chi-Squared Distribution.
        !	    Applied Statistics 24, page 385.
        !
        ! .. note::
        !
        !     Compared to the original R function, we do not use the final
        !     newton step which might lead to values going to infinity for
        !     quantiles close to 1

        real(kind = 8), intent(in) :: p ! the quantile between 0 and 1
        real(kind = 8), intent(in) :: alpha ! the shape of the gamma distribution
        real(kind = 8), intent(in) :: scale ! the scale of the gamma distribution

        real(kind = 8) :: a, b, c, g, ch, ch0, p1
        real(kind = 8) :: p2, q, s1, s2, s3, s4, s5, s6, t, x

        real(kind = 8), parameter :: EPS1 = 1.0e-2, EPS2 = 5.0e-7, &
                                     pMIN = 1.0e-25, pMAX = (1-1e-14), &
                                     pNEGinf = -10e34
        integer, parameter :: MAXIT = 1000
        integer :: i

        if (alpha == 0) then
            gamma_cdf_inv = 0
            goto 10002
        end if
        g = gamma_log(alpha)
        ! ----- Phase I : Starting Approximation
        ch = qchisq_appr(p, 2.0 * alpha, g, EPS1)

        if ((ch < EPS2) .or. (p > pMAX) .or. (p < pMIN)) then
            goto 10002
        end if

        ! ----- Phase II: Iteration
        ! Call pgamma() [AS 239]	and calculate seven term taylor series
        c = alpha - 1.0
        s6 = (120.0 + c * (346.0 + 127.0* c)) / 5040.0

        ch0 = ch  ! save initial approx.
        do i=1,MAXIT
            q = ch
            p1 = 0.5 * ch

            call gamma_cdf(p1 * scale, real(0.0, kind=8), scale, alpha, p2)
            p2 = p - p2

            if (ch <= 0.0) then
                ch = ch0
                goto 10001
            end if

            if ((p2 < pNEGinf) .or. (ch <= 0)) then
                ch = ch0
                goto 10001
            end if

            t = p2*exp(alpha * log(2.0) + g + p1 - c * log(ch))
            b = t / ch
            a = 0.5 * t - b * c
            s1 = (210.0 + a * (140.0 + a * (105.0 + a * (84.0 + a * ( &
                70.0 + 60.0 * a))))) / 420.0
            s2 = (420.0 +  a * (735.0 + a * (966.0 + a * (&
                1141.0 + 1278.0 * a)))) / 2520.
            s3 = (210.0 + a * (462.0 + a * (707.0 + 932.0 * a))) / 2520.0
            s4 = (252.0 + a * (672.0 + 1182.0 * a) + c * (294.0 +a * ( &
                889.0 + 1740.0 * a))) / 5040.0
            s5 = (84.0 + 2264.0 * a + c*(1175.0 + 606.0 * a)) / 2520.0

            ch = ch +  t * (1.0 + 0.5 * t * s1 - b * c * ( &
                s1 - b * (s2 - b * (s3 - b * (s4 - b * (s5 - b * s6))))))

            if (abs(q - ch) < EPS2 * ch) goto 10001

            if (abs(q - ch) > 0.1 * ch) then
                if (ch < q) then
                    ch = 0.9 * q
                else
                    ch = 1.1 * q
                end if
            end if
        end do

    10001 continue

        gamma_cdf_inv = 0.5  * scale * ch

    10002 continue

    end function gamma_cdf_inv

    ! The following functions and subroutines to calculate the gamma distribution
    ! function (gamma_cdf) and the gamma density (gamma_pdf) are taken from
    ! John Burkardt, Department of Scientific Computing at Florida State University (FSU)
    ! http://people.sc.fsu.edu/~jburkardt/f_src/prob/prob.html
    ! on February 23rd, 2016. Last revised on 21 August 2013.

    subroutine gamma_cdf ( x, a, b, c, cdf )
        ! Evaluate the Gamma CDF.
        !
        !  Licensing:
        !    This code is distributed under the GNU LGPL license.
        !  Modified:
        !    02 January 2000
        !    Extracted: June, 2016
        !  Author:
        !    John Burkardt
        !    Extracted by Philipp Sommer
        implicit none

        real ( kind = 8 ), intent(in) :: x    ! the input value for which to compute the CDF
        real ( kind = 8 ), intent(in) :: a    ! the location (< `x`) of the gamma distribution (usually 0)
        real ( kind = 8 ), intent(in) :: b    ! the shape (> 0.0) of the distribution
        real ( kind = 8 ), intent(in) :: c    ! the scale (>0.0) of the distribution
        real ( kind = 8 ), intent(out) :: cdf ! the returned value of the CDF
        real ( kind = 8 ) p2
        real ( kind = 8 ) x2

        x2 = ( x - a ) / b
        p2 = c

        cdf = gamma_inc ( p2, x2 )

        return
    end subroutine gamma_cdf

    !------------------------------------------------------------------------------

    real ( kind = 8 ) function gamma_inc ( p, x )
        ! Compute the incomplete Gamma function.
        !
        ! Formulas:
        !
        !     .. math::
        !
        !         \Gamma_{inc}(P, 0) = 0
        !
        !     .. math::
        !
        !         \Gamma_{inc}(P, \infty) = 1.
        !
        !     .. math::
        !
        !         \Gamma_{inc}(P,X) = \int_0^x{T^{P-1} \exp{(-T)} \mathrm{d}t} / \Gamma(P)
        !
        ! Licensing:
        !     This code is distributed under the GNU LGPL license.
        ! Modified:
        !     - 01 May 2001
        !     - Extracted: June, 2016
        ! Author:
        !     - Original FORTRAN77 version by B L Shea.
        !     - FORTRAN90 version by John Burkardt
        !     - Extracted by Philipp Sommer
        ! Reference:
        !    BL Shea,
        !    Chi-squared and Incomplete Gamma Integral,
        !    Algorithm AS239,
        !    Applied Statistics,
        !    Volume 37, Number 3, 1988, pages 466-473.
        implicit none

        real ( kind = 8 ), intent(in) :: p  ! the exponent parameter (0.0 < P)
        real ( kind = 8 ), intent(in) :: x  ! the integral limit parameter. If X is less than or equal to 0, GAMMA_INC is returned as 0.
        real ( kind = 8 ) a
        real ( kind = 8 ) arg
        real ( kind = 8 ) b
        real ( kind = 8 ) c
        real ( kind = 8 ) cdf
        real ( kind = 8 ), parameter :: exp_arg_min = -88.0D+00
        real ( kind = 8 ), parameter :: overflow = 1.0D+37
        real ( kind = 8 ), parameter :: plimit = 1000.0D+00
        real ( kind = 8 ) pn1
        real ( kind = 8 ) pn2
        real ( kind = 8 ) pn3
        real ( kind = 8 ) pn4
        real ( kind = 8 ) pn5
        real ( kind = 8 ) pn6
        real ( kind = 8 ) rn
        real ( kind = 8 ), parameter :: tol = 1.0D-07
        real ( kind = 8 ), parameter :: xbig = 1.0D+08

        gamma_inc = 0.0D+00

        if ( p <= 0.0D+00 ) then
            write ( *, '(a)' ) ' '
            write ( *, '(a)' ) 'GAMMA_INC - Fatal error!'
            write ( *, '(a)' ) '  Parameter P <= 0.'
            stop 1
        end if

        if ( x <= 0.0D+00 ) then
            gamma_inc = 0.0D+00
            return
        end if
        !
        !  Use a normal approximation if PLIMIT < P.
        !
        if ( plimit < p ) then
            pn1 = 3.0D+00 * sqrt ( p ) * ( ( x / p ) ** ( 1.0D+00 / 3.0D+00 ) &
              + 1.0D+00 / ( 9.0D+00 * p ) - 1.0D+00 )
            call normal_01_cdf ( pn1, cdf )
            gamma_inc = cdf
            return
        end if
        !
        !  Is X extremely large compared to P?
        !
        if ( xbig < x ) then
            gamma_inc = 1.0D+00
            return
        end if
        !
        !  Use Pearson's series expansion.
        !  (P is not large enough to force overflow in the log of Gamma.
        !
        if ( x <= 1.0D+00 .or. x < p ) then

            arg = p * log ( x ) - x - gamma_log ( p + 1.0D+00 )
            c = 1.0D+00
            gamma_inc = 1.0D+00
            a = p

            do

                a = a + 1.0D+00
                c = c * x / a
                gamma_inc = gamma_inc + c

                if ( c <= tol ) then
                    exit
                end if

            end do

            arg = arg + log ( gamma_inc )

            if ( exp_arg_min <= arg ) then
                gamma_inc = exp ( arg )
            else
                gamma_inc = 0.0D+00
            end if

        else
            !
            !  Use a continued fraction expansion.
            !
            arg = p * log ( x ) - x - gamma_log ( p )
            a = 1.0D+00 - p
            b = a + x + 1.0D+00
            c = 0.0D+00
            pn1 = 1.0D+00
            pn2 = x
            pn3 = x + 1.0D+00
            pn4 = x * b
            gamma_inc = pn3 / pn4

            do

                a = a + 1.0D+00
                b = b + 2.0D+00
                c = c + 1.0D+00
                pn5 = b * pn3 - a * c * pn1
                pn6 = b * pn4 - a * c * pn2

                if ( 0.0D+00 < abs ( pn6 ) ) then

                    rn = pn5 / pn6

                    if ( abs ( gamma_inc - rn ) <= min ( tol, tol * rn ) ) then

                        arg = arg + log ( gamma_inc )

                        if ( exp_arg_min <= arg ) then
                            gamma_inc = 1.0D+00 - exp ( arg )
                        else
                            gamma_inc = 1.0D+00
                        end if

                    return

                    end if

                    gamma_inc = rn

                end if

                pn1 = pn3
                pn2 = pn4
                pn3 = pn5
                pn4 = pn6
                !
                !  Rescale terms in continued fraction if terms are large.
                !
                if ( overflow <= abs ( pn5 ) ) then
                    pn1 = pn1 / overflow
                    pn2 = pn2 / overflow
                    pn3 = pn3 / overflow
                    pn4 = pn4 / overflow
                end if

            end do

        end if

        return
    end function gamma_inc

    !------------------------------------------------------------------------------

    real ( kind = 8 ) function gamma_log ( x )
        ! Calculate the natural logarithm of GAMMA ( X ).
        !
        ! Computation is based on an algorithm outlined in references 1 and 2.
        ! The program uses rational functions that theoretically approximate
        ! :math:`\log(\Gamma(X))` to at least 18 significant decimal digits.  The
        ! approximation for 12 < X is from Hart et al, while approximations
        ! for X < 12.0D+00 are similar to those in Cody and Hillstrom,
        ! but are unpublished.
        !
        ! The accuracy achieved depends on the arithmetic system, the compiler,
        ! intrinsic functions, and proper selection of the machine dependent
        ! constants.
        !
        !  Licensing:
        !    This code is distributed under the GNU LGPL license.
        !  Modified:
        !    - 16 June 1999
        !    - Extracted June, 2016
        !  Author:
        !    - Original FORTRAN77 version by William Cody, Laura Stoltz.
        !    - FORTRAN90 version by John Burkardt.
        !    - Extracted by Philipp Sommer
        !  Reference:
        !      - William Cody, Kenneth Hillstrom,
        !        Chebyshev Approximations for the Natural Logarithm of the Gamma Function,
        !        Mathematics of Computation,
        !        Volume 21, 1967, pages 198-203.
        !      - Kenneth Hillstrom,
        !        ANL/AMD Program ANLC366S, DGAMMA/DLGAMA,
        !        May 1969.
        !      - John Hart, Ward Cheney, Charles Lawson, Hans Maehly,
        !        Charles Mesztenyi, John Rice, Henry Thacher, Christoph Witzgall,
        !        Computer Approximations, Wiley, 1968.

        !  Local Parameters:
        !
        !    Local, real ( kind = 8 ) BETA, the radix for the floating-point
        !    representation.
        !
        !    Local, integer MAXEXP, the smallest positive power of BETA that overflows.
        !
        !    Local, real ( kind = 8 ) XBIG, the largest argument for which
        !    LN(GAMMA(X)) is representable in the machine, the solution to the equation
        !      LN(GAMMA(XBIG)) = BETA**MAXEXP.
        !
        !    Local, real ( kind = 8 ) FRTBIG, a rough estimate of the fourth root
        !    of XBIG.
        !
        !  Approximate values for some important machines are:
        !
        !                            BETA      MAXEXP         XBIG     FRTBIG
        !
        !  CRAY-1        (S.P.)        2        8191       9.62D+2461  3.13D+615
        !  Cyber 180/855 (S.P.)        2        1070       1.72D+319   6.44D+79
        !  IEEE (IBM/XT) (S.P.)        2         128       4.08D+36    1.42D+9
        !  IEEE (IBM/XT) (D.P.)        2        1024       2.55D+305   2.25D+76
        !  IBM 3033      (D.P.)       16          63       4.29D+73    2.56D+18
        !  VAX D-Format  (D.P.)        2         127       2.05D+36    1.20D+9
        !  VAX G-Format  (D.P.)        2        1023       1.28D+305   1.89D+76
        !
        implicit none

        real ( kind = 8 ), intent(in) :: x ! the argument of the Gamma function (> 0.0)

        real ( kind = 8 ), parameter, dimension ( 7 ) :: c = (/ &
            -1.910444077728D-03, &
             8.4171387781295D-04, &
            -5.952379913043012D-04, &
             7.93650793500350248D-04, &
            -2.777777777777681622553D-03, &
             8.333333333333333331554247D-02, &
             5.7083835261D-03 /)
        real ( kind = 8 ) corr
        real ( kind = 8 ), parameter :: d1 = -5.772156649015328605195174D-01
        real ( kind = 8 ), parameter :: d2 =  4.227843350984671393993777D-01
        real ( kind = 8 ), parameter :: d4 =  1.791759469228055000094023D+00
        integer ( kind = 4 ) i
        real ( kind = 8 ), parameter :: frtbig = 1.42D+09
        real ( kind = 8 ), parameter, dimension ( 8 ) :: p1 = (/ &
            4.945235359296727046734888D+00, &
            2.018112620856775083915565D+02, &
            2.290838373831346393026739D+03, &
            1.131967205903380828685045D+04, &
            2.855724635671635335736389D+04, &
            3.848496228443793359990269D+04, &
            2.637748787624195437963534D+04, &
            7.225813979700288197698961D+03 /)
        real ( kind = 8 ), parameter, dimension ( 8 ) :: p2 = (/ &
            4.974607845568932035012064D+00, &
            5.424138599891070494101986D+02, &
            1.550693864978364947665077D+04, &
            1.847932904445632425417223D+05, &
            1.088204769468828767498470D+06, &
            3.338152967987029735917223D+06, &
            5.106661678927352456275255D+06, &
            3.074109054850539556250927D+06 /)
        real ( kind = 8 ), parameter, dimension ( 8 ) :: p4 = (/ &
            1.474502166059939948905062D+04, &
            2.426813369486704502836312D+06, &
            1.214755574045093227939592D+08, &
            2.663432449630976949898078D+09, &
            2.940378956634553899906876D+10, &
            1.702665737765398868392998D+11, &
            4.926125793377430887588120D+11, &
            5.606251856223951465078242D+11 /)
        real ( kind = 8 ), parameter :: pnt68 = 0.6796875D+00
        real ( kind = 8 ), parameter, dimension ( 8 ) :: q1 = (/ &
            6.748212550303777196073036D+01, &
            1.113332393857199323513008D+03, &
            7.738757056935398733233834D+03, &
            2.763987074403340708898585D+04, &
            5.499310206226157329794414D+04, &
            6.161122180066002127833352D+04, &
            3.635127591501940507276287D+04, &
            8.785536302431013170870835D+03 /)
        real ( kind = 8 ), parameter, dimension ( 8 ) :: q2 = (/ &
            1.830328399370592604055942D+02, &
            7.765049321445005871323047D+03, &
            1.331903827966074194402448D+05, &
            1.136705821321969608938755D+06, &
            5.267964117437946917577538D+06, &
            1.346701454311101692290052D+07, &
            1.782736530353274213975932D+07, &
            9.533095591844353613395747D+06 /)
        real ( kind = 8 ), parameter, dimension ( 8 ) :: q4 = (/ &
            2.690530175870899333379843D+03, &
            6.393885654300092398984238D+05, &
            4.135599930241388052042842D+07, &
            1.120872109616147941376570D+09, &
            1.488613728678813811542398D+10, &
            1.016803586272438228077304D+11, &
            3.417476345507377132798597D+11, &
            4.463158187419713286462081D+11 /)
        real ( kind = 8 ) res
        real ( kind = 8 ), parameter :: sqrtpi = 0.9189385332046727417803297D+00
        real ( kind = 8 ), parameter :: xbig = 4.08D+36
        real ( kind = 8 ) xden
        real ( kind = 8 ) xm1
        real ( kind = 8 ) xm2
        real ( kind = 8 ) xm4
        real ( kind = 8 ) xnum
        real ( kind = 8 ) xsq
        !
        !  Return immediately if the argument is out of range.
        !
        if ( x <= 0.0D+00 .or. xbig < x ) then
            gamma_log = huge ( gamma_log )
            return
        end if

        if ( x <= epsilon ( x ) ) then

            res = -log ( x )

        else if ( x <= 1.5D+00 ) then

            if ( x < pnt68 ) then
                corr = - log ( x )
                xm1 = x
            else
                corr = 0.0D+00
                xm1 = ( x - 0.5D+00 ) - 0.5D+00
            end if

            if ( x <= 0.5D+00 .or. pnt68 <= x ) then

                xden = 1.0D+00
                xnum = 0.0D+00

                do i = 1, 8
                    xnum = xnum * xm1 + p1(i)
                    xden = xden * xm1 + q1(i)
                end do

                res = corr + ( xm1 * ( d1 + xm1 * ( xnum / xden ) ) )

            else

                xm2 = ( x - 0.5D+00 ) - 0.5D+00
                xden = 1.0D+00
                xnum = 0.0D+00
                do i = 1, 8
                    xnum = xnum * xm2 + p2(i)
                    xden = xden * xm2 + q2(i)
                end do

                res = corr + xm2 * ( d2 + xm2 * ( xnum / xden ) )

            end if

        else if ( x <= 4.0D+00 ) then

            xm2 = x - 2.0D+00
            xden = 1.0D+00
            xnum = 0.0D+00
            do i = 1, 8
                xnum = xnum * xm2 + p2(i)
                xden = xden * xm2 + q2(i)
            end do

            res = xm2 * ( d2 + xm2 * ( xnum / xden ) )

        else if ( x <= 12.0D+00 ) then

            xm4 = x - 4.0D+00
            xden = - 1.0D+00
            xnum = 0.0D+00
            do i = 1, 8
                xnum = xnum * xm4 + p4(i)
                xden = xden * xm4 + q4(i)
            end do

            res = d4 + xm4 * ( xnum / xden )

        else

            res = 0.0D+00

            if ( x <= frtbig ) then

                res = c(7)
                xsq = x * x

                do i = 1, 6
                    res = res / xsq + c(i)
                end do

            end if

            res = res / x
            corr = log ( x )
            res = res + sqrtpi - 0.5D+00 * corr
            res = res + x * ( corr - 1.0D+00 )

        end if

        gamma_log = res

        return
    end function gamma_log

    !------------------------------------------------------------------------------

    subroutine gamma_pdf ( x, a, b, c, pdf )
        ! Evaluate the Gamma PDF.
        !
        ! .. math::
        !
        !     PDF(a,b,c;x) = \exp({-(x-a)/b}) \cdot ((x-a)/b)^{c-1} / (b \cdot \Gamma(c))
        !
        ! - GAMMA_PDF(A,B,C;X), where C is an integer, is the Erlang PDF.
        ! - GAMMA_PDF(A,B,1;X) is the Exponential PDF.
        ! - GAMMA_PDF(0,2,C/2;X) is the Chi Squared PDF with C degrees of freedom.
        !
        ! Licensing:
        !     This code is distributed under the GNU LGPL license.
        ! Modified:
        !     - 02 January 2000
        !     - Extracted: June, 2016
        ! Author:
        !     - John Burkardt
        !     - Extracted by Philipp Sommer
        implicit none

        real ( kind = 8 ), intent(in) :: x    ! the argument of the PDF. A <= X
        real ( kind = 8 ), intent(in) :: a    ! the location of the peak;  A is often chosen to be 0.0.
        real ( kind = 8 ), intent(in) :: b    ! the "scale" parameter; 0.0 < B, and is often 1.0.
        real ( kind = 8 ), intent(in) :: c    ! the "shape" parameter; 0.0 < C, and is often 1.0.
        real ( kind = 8 ), intent(out) :: pdf ! the returned value of the PDF.
        real ( kind = 8 ) y

        if ( x <= a ) then

            pdf = 0.0D+00

        else

            y = ( x - a ) / b

            pdf = y**( c - 1.0D+00 ) / ( b * r8_gamma ( c ) * exp ( y ) )

        end if

        return
    end subroutine gamma_pdf

    !------------------------------------------------------------------------------

    real ( kind = 8 ) function r8_gamma ( x )
        ! Evaluate Gamma(X) for a real argument.
        !
        ! This routine calculates the gamma function for a real argument X.
        !
        ! Computation is based on an algorithm outlined in reference 1.
        ! The program uses rational functions that approximate the gamma
        ! function to at least 20 significant decimal digits.  Coefficients
        ! for the approximation over the interval (1,2) are unpublished.
        ! Those for the approximation for 12 <= X are from reference 2.
        !
        ! Modified:
        !     - 11 February 2008
        !     - Extracted: June, 2016
        !
        ! Author:
        !     - Original FORTRAN77 version by William Cody, Laura Stoltz.
        !     - FORTRAN90 version by John Burkardt.
        !     - Extracted by Philipp Sommer
        ! Reference:
        !     - William Cody,
        !       An Overview of Software Development for Special Functions,
        !       in Numerical Analysis Dundee, 1975,
        !       edited by GA Watson, Lecture Notes in Mathematics 506,
        !       Springer, 1976.
        !     - John Hart, Ward Cheney, Charles Lawson, Hans Maehly,
        !       Charles Mesztenyi, John Rice, Henry Thatcher,
        !       Christoph Witzgall, Computer Approximations, Wiley, 1968,
        !       LC: QA297.C64.

        implicit none

        real ( kind = 8 ), intent(in) :: x ! the argument of the function.
        !
        !  Coefficients for minimax approximation over (12, INF).
        !
        real ( kind = 8 ), dimension ( 7 ) :: c = (/ &
           -1.910444077728D-03, &
            8.4171387781295D-04, &
           -5.952379913043012D-04, &
            7.93650793500350248D-04, &
           -2.777777777777681622553D-03, &
            8.333333333333333331554247D-02, &
            5.7083835261D-03 /)
        real ( kind = 8 ), parameter :: eps = 2.22D-16
        real ( kind = 8 ) fact
        real ( kind = 8 ), parameter :: half = 0.5D+00
        integer ( kind = 4 ) i
        integer ( kind = 4 ) n
        real ( kind = 8 ), parameter :: one = 1.0D+00
        real ( kind = 8 ), dimension ( 8 ) :: p = (/ &
            -1.71618513886549492533811D+00, &
             2.47656508055759199108314D+01, &
            -3.79804256470945635097577D+02, &
             6.29331155312818442661052D+02, &
             8.66966202790413211295064D+02, &
            -3.14512729688483675254357D+04, &
            -3.61444134186911729807069D+04, &
             6.64561438202405440627855D+04 /)
        logical parity
        real ( kind = 8 ), parameter :: pi = 3.1415926535897932384626434D+00
        real ( kind = 8 ), dimension ( 8 ) :: q = (/ &
            -3.08402300119738975254353D+01, &
             3.15350626979604161529144D+02, &
            -1.01515636749021914166146D+03, &
            -3.10777167157231109440444D+03, &
             2.25381184209801510330112D+04, &
             4.75584627752788110767815D+03, &
            -1.34659959864969306392456D+05, &
            -1.15132259675553483497211D+05 /)
        real ( kind = 8 ) res
        real ( kind = 8 ), parameter :: sqrtpi = 0.9189385332046727417803297D+00
        real ( kind = 8 ) sum
        real ( kind = 8 ), parameter :: twelve = 12.0D+00
        real ( kind = 8 ), parameter :: two = 2.0D+00
        real ( kind = 8 ), parameter :: xbig = 171.624D+00
        real ( kind = 8 ) xden
        real ( kind = 8 ), parameter :: xinf = 1.0D+30
        real ( kind = 8 ), parameter :: xminin = 2.23D-308
        real ( kind = 8 ) xnum
        real ( kind = 8 ) y
        real ( kind = 8 ) y1
        real ( kind = 8 ) ysq
        real ( kind = 8 ) z
        real ( kind = 8 ), parameter :: zero = 0.0D+00

        parity = .false.
        fact = one
        n = 0
        y = x
        !
        !  Argument is negative.
        !
        if ( y <= zero ) then

            y = - x
            y1 = aint ( y )
            res = y - y1

            if ( res /= zero ) then

                if ( y1 /= aint ( y1 * half ) * two ) then
                    parity = .true.
                end if

                fact = - pi / sin ( pi * res )
                y = y + one

            else

                res = xinf
                r8_gamma = res
                return

            end if

        end if
        !
        !  Argument is positive.
        !
        if ( y < eps ) then
            !
            !  Argument < EPS.
            !
            if ( xminin <= y ) then
                res = one / y
            else
                res = xinf
                r8_gamma = res
                return
            end if

        else if ( y < twelve ) then

            y1 = y
            !
            !  0.0 < argument < 1.0.
            !
            if ( y < one ) then

                z = y
                y = y + one
            !
            !  1.0 < argument < 12.0.
            !  Reduce argument if necessary.
            !
            else

                n = int ( y ) - 1
                y = y - real ( n, kind = 8 )
                z = y - one

            end if
            !
            !  Evaluate approximation for 1.0 < argument < 2.0.
            !
            xnum = zero
            xden = one
            do i = 1, 8
                xnum = ( xnum + p(i) ) * z
                xden = xden * z + q(i)
            end do

            res = xnum / xden + one
            !
            !  Adjust result for case  0.0 < argument < 1.0.
            !
            if ( y1 < y ) then

                res = res / y1
            !
            !  Adjust result for case 2.0 < argument < 12.0.
            !
            else if ( y < y1 ) then

                do i = 1, n
                    res = res * y
                    y = y + one
                end do

            end if

        else
            !
            !  Evaluate for 12.0 <= argument.
            !
            if ( y <= xbig ) then

                ysq = y * y
                sum = c(7)
                do i = 1, 6
                    sum = sum / ysq + c(i)
                end do
                sum = sum / y - y + sqrtpi
                sum = sum + ( y - half ) * log ( y )
                res = exp ( sum )

            else

                res = xinf
                r8_gamma = res
                return

            end if

        end if
        !
        !  Final adjustments and return.
        !
        if ( parity ) then
            res = - res
        end if

        if ( fact /= one ) then
            res = fact / res
        end if

        r8_gamma = res

        return
    end function r8_gamma

    !------------------------------------------------------------------------------

    subroutine normal_cdf_inv ( cdf, a, b, x )
        ! Invert the Normal CDF.
        !
        ! Licensing:
        !     This code is distributed under the GNU LGPL license.
        ! Modified:
        !     - 23 February 1999
        !     - Extracted: November, 2016
        ! Author:
        !     - John Burkardt
        !     - Extracted by Philipp Sommer
        !
        implicit none

        real ( kind = 8 ), intent(in) :: cdf ! the value of the CDF. 0.0 <= CDF <= 1.0.
        real ( kind = 8 ), intent(in) :: a   ! the mean of the pdf
        real ( kind = 8 ), intent(in) :: b   ! the standard deviation of the pdf
        real ( kind = 8 ), intent(out) :: x  ! the corresponding argument
        real ( kind = 8 ) x2

        if ( cdf < 0.0D+00 .or. 1.0D+00 < cdf ) then
            write ( *, '(a)' ) ' '
            write ( *, '(a)' ) 'NORMAL_CDF_INV - Fatal error!'
            write ( *, '(a)' ) '  CDF < 0 or 1 < CDF.'
            stop 1
        end if

        call normal_01_cdf_inv ( cdf, x2 )

        x = a + b * x2

        return
    end subroutine normal_cdf_inv

    !------------------------------------------------------------------------------

    subroutine normal_01_cdf_inv ( p, x )
        ! Invert the standard normal CDF.
        !
        ! Licensing:
        !     This code is distributed under the GNU LGPL license.
        ! Modified:
        !    - 05 June 2007
        !    - Extracted: November, 2016
        ! Author:
        !     - Original FORTRAN77 version by Michael Wichura.
        !     - FORTRAN90 version by John Burkardt.
        !     - Extracted by Philipp Sommer
        ! Reference:
        !     Michael Wichura,
        !     Algorithm AS241:
        !     The Percentage Points of the Normal Distribution,
        !     Applied Statistics,
        !     Volume 37, Number 3, pages 477-484, 1988.
        !
        ! .. note::
        !
        !     The result is accurate to about 1 part in 10^16.
        !
        implicit none

        real ( kind = 8 ), intent(in) :: p ! the value of the cumulative probability densitity function.  0 < P < 1.
                                           ! If P is outside this range, an "infinite" value will be returned.
        real ( kind = 8 ), intent(out) :: x ! the normal deviate value with the property that the probability of a
                                            ! standard normal deviate being less than or equal to the value is P.

        real ( kind = 8 ), parameter, dimension ( 8 ) :: a = (/ &
            3.3871328727963666080D+00, &
            1.3314166789178437745D+02, &
            1.9715909503065514427D+03, &
            1.3731693765509461125D+04, &
            4.5921953931549871457D+04, &
            6.7265770927008700853D+04, &
            3.3430575583588128105D+04, &
            2.5090809287301226727D+03 /)
        real ( kind = 8 ), parameter, dimension ( 8 ) :: b = (/ &
            1.0D+00, &
            4.2313330701600911252D+01, &
            6.8718700749205790830D+02, &
            5.3941960214247511077D+03, &
            2.1213794301586595867D+04, &
            3.9307895800092710610D+04, &
            2.8729085735721942674D+04, &
            5.2264952788528545610D+03 /)
        real ( kind = 8 ), parameter, dimension ( 8 ) :: c = (/ &
            1.42343711074968357734D+00, &
            4.63033784615654529590D+00, &
            5.76949722146069140550D+00, &
            3.64784832476320460504D+00, &
            1.27045825245236838258D+00, &
            2.41780725177450611770D-01, &
            2.27238449892691845833D-02, &
            7.74545014278341407640D-04 /)
        real ( kind = 8 ), parameter :: const1 = 0.180625D+00
        real ( kind = 8 ), parameter :: const2 = 1.6D+00
        real ( kind = 8 ), parameter, dimension ( 8 ) :: d = (/ &
            1.0D+00, &
            2.05319162663775882187D+00, &
            1.67638483018380384940D+00, &
            6.89767334985100004550D-01, &
            1.48103976427480074590D-01, &
            1.51986665636164571966D-02, &
            5.47593808499534494600D-04, &
            1.05075007164441684324D-09 /)
        real ( kind = 8 ), parameter, dimension ( 8 ) :: e = (/ &
            6.65790464350110377720D+00, &
            5.46378491116411436990D+00, &
            1.78482653991729133580D+00, &
            2.96560571828504891230D-01, &
            2.65321895265761230930D-02, &
            1.24266094738807843860D-03, &
            2.71155556874348757815D-05, &
            2.01033439929228813265D-07 /)
        real ( kind = 8 ), parameter, dimension ( 8 ) :: f = (/ &
            1.0D+00, &
            5.99832206555887937690D-01, &
            1.36929880922735805310D-01, &
            1.48753612908506148525D-02, &
            7.86869131145613259100D-04, &
            1.84631831751005468180D-05, &
            1.42151175831644588870D-07, &
            2.04426310338993978564D-15 /)
        real ( kind = 8 ) q
        real ( kind = 8 ) r
        real ( kind = 8 ), parameter :: split1 = 0.425D+00
        real ( kind = 8 ), parameter :: split2 = 5.0D+00

        if ( p <= 0.0D+00 ) then
            x = - huge ( x )
            return
        end if

        if ( 1.0D+00 <= p ) then
            x = huge ( x )
            return
        end if

        q = p - 0.5D+00

        if ( abs ( q ) <= split1 ) then

            r = const1 - q * q
            x = q * r8poly_value_horner ( 7, a, r ) / r8poly_value_horner ( 7, b, r )

        else

            if ( q < 0.0D+00 ) then
                r = p
            else
                r = 1.0D+00 - p
            end if

            if ( r <= 0.0D+00 ) then

                x = huge ( x )

            else

                r = sqrt ( - log ( r ) )

                if ( r <= split2 ) then

                    r = r - const2
                    x = r8poly_value_horner ( 7, c, r ) / r8poly_value_horner ( 7, d, r )

                else

                    r = r - split2
                    x = r8poly_value_horner ( 7, e, r ) / r8poly_value_horner ( 7, f, r )

                end if

            end if

            if ( q < 0.0D+00 ) then
                x = -x
            end if

        end if

        return
    end subroutine normal_01_cdf_inv

    !------------------------------------------------------------------------------

    real ( kind = 8 ) function r8poly_value_horner ( m, c, x )
        ! Evaluate a polynomial using Horner's method.
        !
        ! The polynomial
        !
        ! .. math::
        !
        !     p(x) = c_0 + c_1 * x + c_2 * x^2 + ... + c_m * x^m
        !
        ! is to be evaluated at the value X.
        !
        ! Licensing:
        !     This code is distributed under the GNU LGPL license.
        ! Modified:
        !     - 02 January 2014
        !     - Extracted: November, 2016
        ! Author:
        !     - John Burkardt
        !     - Extracted by Philipp Sommer
        implicit none

        integer ( kind = 4 ), intent(in) :: m   ! the degree
        real ( kind = 8 ), intent(in) :: c(0:m) ! the polynomial coefficients. C(I) is the coefficient of  :math:`X^I`
        real ( kind = 8 ), intent(in) :: x      ! the polynomial value

        integer ( kind = 4 ) i
        real ( kind = 8 ) value

        value = c(m)
        do i = m - 1, 0, -1
            value = value * x + c(i)
        end do

        r8poly_value_horner = value

        return
    end function r8poly_value_horner

    !------------------------------------------------------------------------------

    subroutine normal_01_cdf ( x, cdf )
        ! evaluate the Normal 01 CDF.
        !
        ! Licensing:
        !     This code is distributed under the GNU LGPL license.
        ! Modified:
        !    - 10 February 1999
        !    - Extracted: June, 2016
        ! Author:
        !     - John Burkardt
        !     - Extracted by Philipp Sommer
        ! Reference:
        !     AG Adams,
        !     Algorithm 39,
        !     Areas Under the Normal Curve,
        !     Computer Journal,
        !     Volume 12, pages 197-198, 1969.
        implicit none

        real ( kind = 8 ), intent(in) :: x ! the argument of the CDF.
        real ( kind = 8 ), intent(out) :: cdf ! the value of the CDF.

        real ( kind = 8 ), parameter :: a1 = 0.398942280444D+00
        real ( kind = 8 ), parameter :: a2 = 0.399903438504D+00
        real ( kind = 8 ), parameter :: a3 = 5.75885480458D+00
        real ( kind = 8 ), parameter :: a4 = 29.8213557808D+00
        real ( kind = 8 ), parameter :: a5 = 2.62433121679D+00
        real ( kind = 8 ), parameter :: a6 = 48.6959930692D+00
        real ( kind = 8 ), parameter :: a7 = 5.92885724438D+00
        real ( kind = 8 ), parameter :: b0 = 0.398942280385D+00
        real ( kind = 8 ), parameter :: b1 = 3.8052D-08
        real ( kind = 8 ), parameter :: b2 = 1.00000615302D+00
        real ( kind = 8 ), parameter :: b3 = 3.98064794D-04
        real ( kind = 8 ), parameter :: b4 = 1.98615381364D+00
        real ( kind = 8 ), parameter :: b5 = 0.151679116635D+00
        real ( kind = 8 ), parameter :: b6 = 5.29330324926D+00
        real ( kind = 8 ), parameter :: b7 = 4.8385912808D+00
        real ( kind = 8 ), parameter :: b8 = 15.1508972451D+00
        real ( kind = 8 ), parameter :: b9 = 0.742380924027D+00
        real ( kind = 8 ), parameter :: b10 = 30.789933034D+00
        real ( kind = 8 ), parameter :: b11 = 3.99019417011D+00
        real ( kind = 8 ) q
        real ( kind = 8 ) y
        !
        !  |X| <= 1.28.
        !
        if ( abs ( x ) <= 1.28D+00 ) then

            y = 0.5D+00 * x * x

            q = 0.5D+00 - abs ( x ) * ( a1 - a2 * y / ( y + a3 - a4 / ( y + a5 &
              + a6 / ( y + a7 ) ) ) )
        !
        !  1.28 < |X| <= 12.7
        !
        else if ( abs ( x ) <= 12.7D+00 ) then

            y = 0.5D+00 * x * x

            q = exp ( - y ) * b0 / ( abs ( x ) - b1 &
                + b2 / ( abs ( x ) + b3 &
                + b4 / ( abs ( x ) - b5 &
                + b6 / ( abs ( x ) + b7 &
                - b8 / ( abs ( x ) + b9 &
                + b10 / ( abs ( x ) + b11 ) ) ) ) ) )
        !
        !  12.7 < |X|
        !
        else

            q = 0.0D+00

        end if
        !
        !  Take account of negative X.
        !
        if ( x < 0.0D+00 ) then
            cdf = q
        else
            cdf = 1.0D+00 - q
        end if

        return
    end subroutine normal_01_cdf

end module randomdistmod

module geohashmod
    ! Module for setting the seed based upon the location on the earth

    use parametersmod, only : sp,dp,i4

    implicit none

    integer(i4), parameter :: mv = huge(i4)  !add offset to fit into values into signed number

    contains

    !------

    integer(i4) function geohash(lon,lat)
        ! encode a lon and lat pair into a signed 4-byte integer
        !
        ! original use: to seed a random number generator in a predictable but geographically non-uniform way
        ! this should be precise and provide a unique number down to 30 arc-second resolution (1km)
        ! Jed O. Kaplan, 2011

        implicit none

        real(sp), intent(in) :: lon ! the longitude
        real(sp), intent(in) :: lat ! the latitude

        real(sp),    parameter :: scale  = 120.d0      !scale factor for geohash, the larger the number the more unique values
        real(sp),    parameter :: offset =   0.5d0     !offset to calculate pixel number assuming gridcell center coordinates are given
        integer(i4), parameter :: rowlen = nint(scale * 360.d0)

        integer(i4) :: i,j

        !---

        i = nint(offset + scale * (lon + 180.d0))
        j = nint(offset + scale * (lat + 90.d0))

        geohash = i + rowlen * (j-1) - mv

    end function geohash

    !------

end module geohashmod

module parametersmod
    ! Simple module defining some types and parameters

    implicit none

    integer, parameter :: dp = selected_real_kind(9)      ! 8 byte real
    integer, parameter :: sp = selected_real_kind(4)      ! 4 byte real
    integer, parameter :: i4 = selected_int_kind(9)       ! 10^9 fits into 4 bytes

    integer, parameter, dimension(12) :: ndaymonth = (/ 31,28,31,30,31,30,31,31,30,31,30,31 /) ! number of days in each month

    real(sp), parameter :: Tfreeze = 273.15      ! freezing temperature of freshwater (K)

end module parametersmod

module parseghcnrow

contains

subroutine parse_station(infile, ndays, stationid, dates, variables, flags, j)

implicit none

character(11), intent(out) :: stationid

integer :: year
integer :: month

character(4) :: variable

character(300), intent(in) :: infile
integer, intent(in) :: ndays

! returns
integer, intent(out)       :: dates(ndays, 3), j
real, intent(out)          :: variables(ndays, 3)
character(1), intent(out)  :: flags(ndays, 3, 3)

integer, parameter, dimension(12) :: ndm_normal = [ 31,28,31, 30, 31, 30, 31, 31, 30, 31, 30, 31 ]  !number of days in each month
integer, parameter, dimension(12) :: ndm_leapyr = [ 31,29,31, 30, 31, 30, 31, 31, 30, 31, 30, 31 ]  !number of days in each month

integer, dimension(12) :: ndaymon

character(269) :: values

real,dimension(31) :: tmax
real,dimension(31) :: tmin
real,dimension(31) :: prcp

character(1), dimension(31,3) :: tmin_flags
character(1), dimension(31,3) :: tmax_flags
character(1), dimension(31,3) :: prcp_flags

integer :: d
integer :: start

integer :: lastmonth
integer :: lastyear

real, parameter :: missing = -9999.


!----

open(10,file=infile,status='old')

20 format(a11,i4,i2,a4,a247)

lastyear = 0
lastmonth = 0

do

    read(10,20,end=99)stationid,year,month,variable,values
    if (variable == 'PRCP' .or. variable == 'TMAX' .or. variable == 'TMIN') then

        !initialize variables

        lastmonth = month
        lastyear = year
        exit
    end if
end do

if (lastmonth == 0) then
    STOP 'Could not find any data for tmin, tmax or prcp'
end if

tmin = missing
tmax = missing
prcp = missing

tmin_flags = ''
tmax_flags = ''
prcp_flags = ''

rewind(10)

!----
j = 1
do !read one month of one variable per row

  read(10,20,end=99)stationid,year,month,variable,values

  if (variable /= 'PRCP' .and. variable /= 'TMAX' .and. variable /= 'TMIN') cycle

  if (year /= lastyear .or. month /= lastmonth) then

    !write out the data

    do d = 1,ndaymon(lastmonth)
      dates(j, :) = (/lastyear, lastmonth, d/)
      variables(j, :) = (/tmin(d), tmax(d), prcp(d)/)
      flags(j, 1, :) = tmin_flags(d,:)
      flags(j, 2, :) = tmax_flags(d,:)
      flags(j, 3, :) = prcp_flags(d,:)
      j = j + 1
    end do

    lastmonth = month
    lastyear  = year

    tmin = missing
    tmax = missing
    prcp = missing

    tmin_flags = ''
    tmax_flags = ''
    prcp_flags = ''

  end if

  if (leapyear(year)) then
    ndaymon = ndm_leapyr
  else
    ndaymon = ndm_normal
  end if

  do d = 1,ndaymon(month)

    start = 1+8*(d-1)

    !convert the value into a real number

    if (variable == 'TMAX') then

      read(values(start:start+4),*)tmax(d)
      !apply the scale factor
      tmax(d) = tmax(d) * 0.1
      ! Set values smaller than -100 degC to NaN
      if (tmax(d) < -100.0) tmax(d) = missing

      tmax_flags(d,1) = values(start+5:start+5)
      tmax_flags(d,2) = values(start+6:start+6)
      tmax_flags(d,3) = values(start+7:start+7)

    else if (variable == 'TMIN') then

      read(values(start:start+4),*)tmin(d)
      !apply the scale factor
      tmin(d) = tmin(d) * 0.1
      ! Set values smaller than -100 degC to NaN
      if (tmin(d) < -100.0) tmin(d) = missing

      tmin_flags(d,1) = values(start+5:start+5)
      tmin_flags(d,2) = values(start+6:start+6)
      tmin_flags(d,3) = values(start+7:start+7)

    else if (variable == 'PRCP') then

      read(values(start:start+4),*)prcp(d)
      !apply the scale factor
      prcp(d) = prcp(d) * 0.1
      if (prcp(d) < 0.0) prcp(d) = missing

      prcp_flags(d,1) = values(start+5:start+5)
      prcp_flags(d,2) = values(start+6:start+6)
      prcp_flags(d,3) = values(start+7:start+7)

    end if

  end do
end do

99 continue

if (lastmonth > 0) then
  do d = 1,ndaymon(lastmonth)
    dates(j, :) = (/lastyear, lastmonth, d/)
    variables(j, :) = (/tmin(d), tmax(d), prcp(d)/)
    flags(j, 1, :) = tmin_flags(d,:)
    flags(j, 2, :) = tmax_flags(d,:)
    flags(j, 3, :) = prcp_flags(d,:)
    j = j + 1
  end do
end if
j = j - 1

end subroutine parse_station

!----

logical function leapyear(year)

integer, intent(in) :: year

if ((mod(year,4) == 0 .and. mod(year,100) /= 0) .or. mod(year,400) == 0) then

  leapyear = .true.

else

  leapyear = .false.

end if

end function leapyear

!----

end module parseghcnrow

module parseeecra

use omp_lib

contains

subroutine parse_file( &
    infile, year, nrecords, &
    yr,mn,dy,hr,      & !   year,month,day,hour
    IB,               & !   sky brightness indicator
    LAT,              & !   latitude
    LON,              & !   longitude
    station_id,       & !   land: station number, ship: source deck, ship type
    LO,               & !   land/ocean indicator
    ww,               & !   present weather
    N,                & !   total cloud cover
    Nh,               & !   lower cloud amount
    h,                & !   lower cloud base height
    CL,               & !   low cloud type
    CM,               & !   middle cloud type
    CH,               & !   high cloud type
    AM,               & !   middle cloud amount
    AH,               & !   high cloud amount
    UM,               & !   middle cloud amount
    UH,               & !   high cloud amount
    IC,               & !   change code
    SA,               & !   solar altitude
    RI,               & !   relative lunar illuminance
    SLP,              & !   sea level pressure
    WS,               & !   wind speed
    WD,               & !   wind direction (degrees)
    AT,               & !   air temperature
    DD,               & !   dew point depression
    EL,               & !   Land: station elevation (m)
    IW,               & !   wind speed indicator
    IP)                 !  Land: sea level pressure flag
    !   year,month,day,hour          yr,mn,dy,hr    8   51120100  96113021    none
    !   sky brightness indicator        IB          1          0         1    none
    !   latitude  x100                  LAT         5      -9000      9000    none
    !   longitude x100                  LON         5          0     36000    none
    !   land: station number            ID          5      01000     98999    none
    !   ship: source deck, ship type                        1100      9999  none,9
    !   land/ocean indicator            LO          1          1         2    none
    !   present weather                 ww          2          0        99      -1
    !   total cloud cover               N           1          0         8    none
    !   lower cloud amount              Nh          2         -1         8      -1
    !   lower cloud base height         h           2         -1         9      -1
    !   low cloud type                  CL          2         -1        11      -1
    !   middle cloud type               CM          2         -1        12      -1
    !   high cloud type                 CH          2         -1         9      -1
    !   middle cloud amount x100        AM          3          0       800     900
    !   high cloud amount x100          AH          3          0       800     900
    !   middle cloud amount           UM          1          0         8       9
    !   high cloud amount             UH          1          0         8       9
    !   change code                     IC          2          0         9    none
    !   solar altitude (deg x10)        SA          4       -900       900    none
    !   relative lunar illuminance x100 RI          4       -110       117    none
    !   sea level pressure (mb x10)     SLP         5       9000,L   10999,L    -1
    !   wind speed (ms-1 x10)           WS          3          0       999      -1
    !   wind direction (degrees)        WD          3          0       361      -1
    !   air temperature (C x10)         AT          4       -949,L     599,L   900
    !   dew point depression (C x10)    DD          3          0       700     900
    !   Land: station elevation (m)     EL          4       -350      4877    9000
    !   wind speed indicator            IW          1          0         1       9
    !  Land: sea level pressure flag   IP          1          0)
    implicit none

    character(300), intent(in) :: infile
    integer, intent(in) :: nrecords, year
    integer, dimension(nrecords), intent(out) :: &
      yr,mn,dy,hr,      & !   year,month,day,hour
      IB,               & !   sky brightness indicator
      station_id,       & !   land: station number, ship: source deck, ship type
      LO,               & !   land/ocean indicator
      ww,               & !   present weather
      N,                & !   total cloud cover
      Nh,               & !   lower cloud amount
      h,                & !   lower cloud base height
      CL,               & !   low cloud type
      CM,               & !   middle cloud type
      CH,               & !   high cloud type
      UM,               & !   middle cloud amount
      UH,               & !   high cloud amount
      IC,               & !   change code
      WD,               & !   wind direction (degrees)
      EL,               & !   Land: station elevation (m)
      IW,               & !   wind speed indicator
      IP                  !  Land: sea level pressure flag
    real, dimension(nrecords), intent(out) :: &
      LAT,              & !   latitude
      LON,              & !   longitude
      AM,               & !   middle cloud amount
      AH,               & !   high cloud amount
      SA,               & !   solar altitude
      RI,               & !   relative lunar illuminance
      SLP,              & !   sea level pressure
      WS,               & !   wind speed
      AT,               & !   air temperature
      DD                  !   dew point depression
    integer :: i

    open(10,file=infile,status='old')

    20 format(i2,i2,i2,i2, & ! yr,mn,dy,hr
              i1,          & ! IB
              f5.0,          & ! LAT
              f5.0,          & ! LON
              i5,          & ! station_id
              i1,          & ! LO
              i2,          & ! ww
              i1,          & ! N
              i2,          & ! Nh
              i2,          & ! h
              i2,          & ! CL
              i2,          & ! CM
              i2,          & ! CH
              f3.0,          & ! AM
              f3.0,          & ! AH
              i1,          & ! UM
              i1,          & ! UH
              i2,          & ! IC
              f4.0,          & ! SA
              f4.0,          & ! RI
              f5.0,          & ! SLP
              f3.0,          & ! WS
              i3,          & ! WD
              f4.0,          & ! AT
              f3.0,          & ! DD
              i4,          & ! EL
              i1,          & ! IW
              i1)            ! IP
    21 format(i4,i2,i2,i2, & ! yr,mn,dy,hr
              i1,          & ! IB
              f5.0,          & ! LAT
              f5.0,          & ! LON
              i5,          & ! station_id
              i1,          & ! LO
              i2,          & ! ww
              i1,          & ! N
              i2,          & ! Nh
              i2,          & ! h
              i2,          & ! CL
              i2,          & ! CM
              i2,          & ! CH
              f3.0,          & ! AM
              f3.0,          & ! AH
              i1,          & ! UM
              i1,          & ! UH
              i2,          & ! IC
              f4.0,          & ! SA
              f4.0,          & ! RI
              f5.0,          & ! SLP
              f3.0,          & ! WS
              i3,          & ! WD
              f4.0,          & ! AT
              f3.0,          & ! DD
              i4,          & ! EL
              i1,          & ! IW
              i1)            ! IP
    do i=1,nrecords
        if (year < 1997) then
            read(10,20) yr(i),mn(i),dy(i),hr(i),IB(i),LAT(i),LON(i),station_id(i), &
                       LO(i),ww(i),N(i),Nh(i),h(i),CL(i),CM(i),CH(i),AM(i),AH(i), &
                       UM(i),UH(i),IC(i),SA(i),RI(i),SLP(i),WS(i),WD(i),AT(i),DD(i), &
                       EL(i),IW(i),IP(i)
            yr(i) = yr(i) + 1900
        else
            read(10,21) yr(i),mn(i),dy(i),hr(i),IB(i),LAT(i),LON(i),station_id(i), &
                       LO(i),ww(i),N(i),Nh(i),h(i),CL(i),CM(i),CH(i),AM(i),AH(i), &
                       UM(i),UH(i),IC(i),SA(i),RI(i),SLP(i),WS(i),WD(i),AT(i),DD(i), &
                       EL(i),IW(i),IP(i)
        endif
        if (LON(i) > 18000) LON(i) = LON(i) - 36000
        LAT(i) = LAT(i) * 0.01
        LON(i) = LON(i) * 0.01
        AM(i) = AM(i) * 0.01
        AH(i) = AH(i) * 0.01
        SA(i) = SA(i) * 0.01
        RI(i) = RI(i) * 0.01
        SLP(i) = SLP(i) * 0.01
        WS(i) = WS(i) * 0.1
        AT(i) = AT(i) * 0.1
        DD(i) = DD(i) * 0.1
    end do

end subroutine parse_file

subroutine extract_data(ids, src_dir, odir, years, imonths)

    implicit none

    integer, intent(in), dimension(:) :: ids, years, imonths
    character*300, intent(in) :: src_dir, odir

    INTEGER :: &
        yr,mn,dy,hr,      & !   year,month,day,hour          yr,mn,dy,hr    8   51120100  96113021    none
        IB,               & !   sky brightness indicator        IB          1          0         1    none
        LAT,              & !   latitude  x100                  LAT         5      -9000      9000    none
        LON,              & !   longitude x100                  LON         5          0     36000    none
        station_id,       & !   land: station number            ID          5      01000     98999    none
                            !   ship: source deck, ship type                        1100      9999  none,9
        LO,               & !   land/ocean indicator            LO          1          1         2    none
        ww,               & !   present weather                 ww          2          0        99      -1
        N,                & !   total cloud cover               N           1          0         8    none
        Nh,               & !   lower cloud amount              Nh          2         -1         8      -1
        h,                & !   lower cloud base height         h           2         -1         9      -1
        CL,               & !   low cloud type                  CL          2         -1        11      -1
        CM,               & !   middle cloud type               CM          2         -1        12      -1
        CH,               & !   high cloud type                 CH          2         -1         9      -1
        AM,               & !   middle cloud amount x100        AM          3          0       800     900
        AH,               & !   high cloud amount x100          AH          3          0       800     900
        UM,               & !   middle cloud amount           UM          1          0         8       9
        UH,               & !   high cloud amount             UH          1          0         8       9
        IC,               & !   change code                     IC          2          0         9    none
        SA,               & !   solar altitude (deg x10)        SA          4       -900       900    none
        RI,               & !   relative lunar illuminance x100 RI          4       -110       117    none
        SLP,              & !   sea level pressure (mb x10)     SLP         5       9000,L   10999,L    -1
        WS,               & !   wind speed (ms-1 x10)           WS          3          0       999      -1
        WD,               & !   wind direction (degrees)        WD          3          0       361      -1
        AT,               & !   air temperature (C x10)         AT          4       -949,L     599,L   900
        DD,               & !   dew point depression (C x10)    DD          3          0       700     900
        EL,               & !   Land: station elevation (m)     EL          4       -350      4877    9000
        IW,               & !   wind speed indicator            IW          1          0         1       9
        IP                  !  Land: sea level pressure flag   IP          1          0         2       9

    integer(kind = OMP_lock_kind) :: lck = 0
    integer(kind = OMP_lock_kind), dimension(size(ids)) :: locks
    integer :: ID
    integer :: j = 0, i = 0, nids = 0, keep = 0, old_id = 0, year = 0, &
               imonth = 0, iyear = 0
    integer, dimension(size(ids)) :: ounits
    integer, dimension(100) :: inunits = 0
    character*350, dimension(size(ids)) :: ofiles
    character*90 :: cfmt
    character*300 :: all_cfmt
    character*350 :: fname
    character*10 :: cid
    character*2 :: cyear
    character(len=3), dimension(12) :: months = (/ &
        'JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN', 'JUL', 'AUG', 'SEP', 'OCT', &
        'NOV', 'DEC' /)
    logical :: file_exists

    !       mn,dy,hr,IB,la,lo,id,LO,ww,N ,Nh,h ,CL,CM,CH,AM,AH,UM,UH,IC,SA,RI,SLP,WS,WD,AT,DD,EL,IW,IP
    cfmt = 'i2,i2,i2,i1,i5,i5,i5,i1,i2,i1,i2,i2,i2,i2,i2,i3,i3,i1,i1,i2,i4,i4,i5,i3 ,i3,i4,i3,i4,i1,i1'

    ! output format
    25 format(i4,a,i0.2,a,i0.2,a,i0.2, & ! yr,mn,dy,hr
              a,           &
              i1,          & ! IB
              a,           &
              f6.2,        & ! LAT
              a,           &
              f6.2,        & ! LON
              a,           &
              i5,          & ! station_id
              a,           &
              i1,          & ! LO
              a,           &
              i2,          & ! ww
              a,           &
              i1,          & ! N
              a,           &
              i2,          & ! Nh
              a,           &
              i2,          & ! h
              a,           &
              i2,          & ! CL
              a,           &
              i2,          & ! CM
              a,           &
              i2,          & ! CH
              a,           &
              f4.2,        & ! AM
              a,           &
              f5.2,        & ! AH
              a,           &
              i1,          & ! UM
              a,           &
              i1,          & ! UH
              a,           &
              i2,          & ! IC
              a,           &
              f5.1,        & ! SA
              a,           &
              f5.2,        & ! RI
              a,           &
              f6.1,        & ! SLP
              a,           &
              f4.1,        & ! WS
              a,           &
              i3,          & ! WD
              a,           &
              f5.1,        & ! AT
              a,           &
              f4.1,        & ! DD
              a,           &
              i4,          & ! EL
              a,           &
              i1,          & ! IW
              a,           &
              i1)            ! IP

nids = size(ids)

j = 11
do i = 1, nids
    locks(i) = i
    call OMP_init_lock(locks(i))
    write(cid, '(I10)') ids(i)
    ofiles(i) = trim(odir)//trim(adjustl(cid))//'.csv'
    ounits(i) = j + 1000
    open(10, file=trim(ofiles(i)), status='unknown',action='write')
    write(10,'(a)') 'year,month,day,hour,IB,lat,lon,station_id,LO,ww,N,Nh,h,CL,CM,CH,AM,AH,UM,UH,IC,SA,RI,SLP,WS,WD,AT,DD,EL,IW,IP'
    j = j + 1
    close(10, status='keep')
end do

call OMP_init_lock(lck)

do i = 1,size(inunits)
    inunits(i) = i + 50
end do

!$OMP PARALLEL DO SHARED(lck,locks,src_dir,odir,nids,ids,months,inunits,ounits, &
!$OMP&                  ofiles,cfmt,imonths,years), &
!$OMP FIRSTPRIVATE(old_id,keep), &
!$OMP& PRIVATE(yr,mn,dy,hr,IB,LAT,LON,station_id,LO,ww,N,Nh, h,CL,CM,CH,AM,AH, &
!$OMP&         UM,UH,IC,SA,RI,SLP,WS,WD,AT, DD,EL,IW,IP,fname,cid,i,ID,imonth, &
!$OMP&         cyear,year,all_cfmt,iyear,j)
do iyear = 1,size(years)
    year = years(iyear)
    ID = OMP_get_thread_num() + 1
    call OMP_set_lock(lck)
    write(*,*) "My thread is ", ID, '. Processing year ', year
    call OMP_unset_lock(lck)
    if (year < 1997) then
        all_cfmt = '(i2,'//cfmt//')'
    else
        all_cfmt = '(i4,'//cfmt//')'
    endif
    do imonth = 1,size(imonths)
        write(cyear,'(I0.2)') mod(year, 100)
        fname = trim(src_dir)//months(imonths(imonth))//cyear//'L'
        inquire(file=fname,EXIST=file_exists)
        if (.not. file_exists) goto 99
        open(inunits(ID), file=fname, status='old', action='read')
        j = 1
        do
            read(inunits(ID),all_cfmt,end=99,err=98) yr,mn,dy,hr,IB,LAT,LON, &
                               station_id,LO,ww,N,Nh,h,CL,CM,CH,AM,AH,UM,UH, &
                               IC,SA,RI,SLP,WS,WD,AT,DD,EL,IW,IP
            if (year < 1997) yr = yr + 1900
            if (old_id /= station_id) then
                if (keep /= 0) then
                    close(ounits(keep))
                    call OMP_unset_lock(locks(keep))
                endif
                keep = 0
                do i = 1, nids
                    if (station_id == ids(i)) then
                        keep = i
                        call OMP_set_lock(locks(keep))
                        write(cid, '(I10)') ids(i)
                        open(ounits(keep), file=trim(ofiles(keep)), &
                             status='old',access='append',action='write')
                    endif
                end do
                old_id = station_id
            endif
            if (keep > 0) then
                if (LON > 18000) LON = LON - 36000
                write(ounits(keep),25) yr,',',mn,',',dy,',',hr,',',IB,',', &
                             0.01*LAT,',',0.01*LON,',',station_id,',', &
                             LO,',',ww,',',N,',',Nh,',',h,',',CL,',', &
                             CM,',',CH,',',0.01*AM,',',0.01*AH,',',UM, &
                             ',',UH,',',IC,',',0.1*SA,',',0.01*RI,',', &
                             0.1*SLP,',',0.1*WS,',',WD,',',0.1*AT,',', &
                             0.1*DD,',',EL,',',IW,',',IP
            end if
            j = j + 1
            goto 97
98 continue
            write(*,*) "Error occured at line ", j, "of file ", fname
97 continue
        end do
99 continue
    close(inunits(ID))
    if (keep /= 0) then
        close(ounits(keep))
        call OMP_unset_lock(locks(keep))
        keep = 0
    endif
    end do
end do
!$OMP END PARALLEL DO

call OMP_destroy_lock(lck)
do i=1,nids
    call OMP_destroy_lock(locks(i))
end do
end subroutine extract_data

end module parseeecra
